<?php
/**
 * 单据打印
 * Created by PhpStorm.
 * User: XiaoMing
 * Date: 2020/4/17
 * Time: 16:59
 */

namespace JinDouYun\Controller\Common;

use JinDouYun\Controller\BaseController;
use JinDouYun\Model\System\MPrintNum;
use Mall\Framework\Core\ErrorCode;

class PrintNum extends BaseController
{
    private $objMPrintNum;

    /**
     * PrintNum constructor.
     * @param bool $isCheckAcl
     * @param bool $isMustLogin
     * @param bool $checkToken
     */
    public function __construct($isCheckAcl = false, $isMustLogin = false, $checkToken = true)
    {
        parent::__construct($isCheckAcl, $isMustLogin, $checkToken);
        $this->objMPrintNum = new MPrintNum($this->onlineEnterpriseId);
    }

    /**
     * 增加打印次数
     */
    public function printIncr()
    {
        $params = $this->request->getRawJson();
        $objectNo = isset($params['objectNo']) ? $params['objectNo'] : null;
        $objectType = isset($params['objectType']) ? $params['objectType'] : null;
        if (empty($objectNo) || empty($objectType)) {
            parent::sendOutput('参数错误', ErrorCode::$paramError);
        }
        $result = $this->objMPrintNum->printIncr($objectNo, $objectType);
        if ($result->isSuccess()) {
            parent::sendOutput($result->getData());
        }
        parent::sendOutput($result->getData(), $result->getErrorCode());
    }
}