<?php
/**
 * 供应商余额管理模块
 * Created by PhpStorm.
 * User: tpl
 * Date: 2019/10/30
 * Time: 13:54
 */
namespace JinDouYun\Controller\Finance;

use Mall\Framework\Core\ErrorCode;
use Mall\Framework\Core\StatusCode;

use JinDouYun\Controller\BaseController;
use JinDouYun\Model\Finance\MSupplierBalance;

class SupplierBalance extends BaseController
{
    private $objMSupplierBalance;

    public function __construct($isCheckAcl = true, $isMustLogin = true)
    {
        parent::__construct($isCheckAcl, $isMustLogin);
        $this->objMSupplierBalance = new MSupplierBalance($this->onlineEnterpriseId, $this->onlineUserId);
    }

    /**
     * 添加供应商余额
     */
    public function addSupplierBalance()
    {
        $supplierBalanceData = $this->commonFieldFilter();

        $result = $this->objMSupplierBalance ->addSupplierBalance($supplierBalanceData);
        if($result->isSuccess()){
            parent::sendOutput($result->getData());
        }else{
            parent::sendOutput($result->getData(), $result->getErrorCode());
        }

    }

    /**
     * 后台所有供应商余额列表
     */
    public function getAllSupplierBalance()
    {
        $params = $this->request->getRawJson();
        if( empty($params) ){
            $this->sendOutput('参数为空', ErrorCode::$paramError );
        }

        //接收供应商Id
        //接收开始日期和结束日期
        $selectParams = [
            'supplierId' => isset($params['supplierId']) ? $params['supplierId'] : '',
            'start' => isset($params['start']) ? $params['start'] : '',
            'end' => isset($params['end']) ? $params['end'] : '',
        ];

        if($selectParams['start'] && $selectParams['end']) {
            if(empty($selectParams['supplierId'])) {
                $this->sendOutput('请选择供应商', ErrorCode::$paramError);
            }
        }

        if(isset($params['isExport']) && $params['isExport']){
            $selectParams['isExport'] = $params['isExport'];
        }

        $pageParams = pageToOffset($params['page']?:1, $params['pageSize']?:10);
        $selectParams['limit'] = $pageParams['limit'];
        $selectParams['offset'] = $pageParams['offset'];
        $result = $this->objMSupplierBalance->getAllSupplierBalance($selectParams);

        if($result->isSuccess()){
            $returnData = $result->getData();
            $pageData = [
                'pageIndex' => $params['page'],
                'pageSize' => $params['pageSize'],
                'pageTotal' => $returnData['total'],
            ];
            parent::sendOutput($returnData['data'], 0, $pageData);
        }else{
            parent::sendOutput($result->getData(), $result->getErrorCode());
        }
    }
}