<?php
/**
 * 活动
 * Created by PhpStorm.
 * User: XiaoMing
 * Date: 2019/12/26
 * Time: 9:21
 */

namespace JinDouYun\Controller\Market;

use JinDouYun\Controller\BaseController;
use JinDouYun\Model\Market\MActivity;
use Mall\Framework\Core\ErrorCode;

class ApiActivity extends BaseController
{
    private $objMActivity;

    /**
     * ApiActivity constructor.
     * @param bool $isCheckAcl
     * @param bool $isMustLogin
     * @param bool $checkToken
     * @param bool $getAreaCode
     * @throws \Exception
     */
    public function __construct($isCheckAcl = false, $isMustLogin = false,$checkToken=true,$getAreaCode=true)
    {
        parent::__construct($isCheckAcl, $isMustLogin, $checkToken,$getAreaCode);
        $authorization = $this->request->getServerParam('HTTP_AUTHORIZATION');
        if (!empty($authorization)) {
            self::getUserIdByAuthorization();
        }
        $this->objMActivity = new MActivity($this->onlineUserId, $this->onlineEnterpriseId,$this->areaCode);
    }

    /**
     * @throws \Exception
     */
    public function getActivityAll()
    {
        $dbResult = $this->objMActivity->getActivityAll();
        if ($dbResult->isSuccess()) {
            $returnData = $dbResult->getData();
            parent::sendOutput($returnData['data'], 0);
        }
        parent::sendOutput($dbResult->getData(), ErrorCode::$dberror);
    }
}