<?php


namespace JinDouYun\Dao\Cashier;


use JinDouYun\Dao\BaseDao;

/**
 * Description:
 * Class DCashierConnectLog
 * @package JinDouYun\Dao\Cashier
 */
class DCashierConnectLog extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'cashier_connect_log';
        $this->_primary = 'id';
        $this->_fields = [
            "id",//int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
            "staffName",//varchar(255) DEFAULT '' COMMENT '收银员姓名',
            "mobile",//varchar(50) DEFAULT '' COMMENT '手机号',
            "atWorkTime",//int(10) DEFAULT '0' COMMENT '上班时间',
            "offDutyTime",//int(10) DEFAULT '0' COMMENT '下班时间',
            "hours",//varchar(50) default ''  COMMENT '时长',
            "remark",//varchar(255) default ''  COMMENT '备注',
            "collectionMoney",//decimal(10,2) DEFAULT '0.00' COMMENT '收款金额',
            "shopId",//int(10) DEFAULT '0' COMMENT '店铺id',
            "collectionData",//json DEFAULT NULL COMMENT '收款数据',
            "rechargeData",//json DEFAULT NULL COMMENT '充值数据',
            "rechargeMoney",//decimal(10,2) DEFAULT '0.00' COMMENT '充值金额',
            "refundData",//json DEFAULT NULL COMMENT '退款数据',
            "refundMoney",//decimal(10,2) DEFAULT '0.00' COMMENT '退款金额',
            "createTime",//int(10) DEFAULT '0' COMMENT '创建时间',
            "updateTime",//int(10) DEFAULT '0' COMMENT '修改时间',
            "workStatus",//
            "extend",//json DEFAULT NULL COMMENT '扩展字段',
            "userCenterId",//收银员id
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}