<?php


namespace JinDouYun\Dao\Cashier;


use JinDouYun\Dao\BaseDao;

/**
 * Description:
 * Class DCashierCustomerPrice
 * @package JinDouYun\Dao\Cashier
 */
class DCashierCustomerPrice extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'cashier_customer_price';
        $this->_primary = 'id';
        $this->_fields = [
            "id",//int(10) NOT NULL AUTO_INCREMENT,
            "skuId",//int(10) NOT NULL default '0' COMMENT 'skuId',
            "cashierUid",//int(10) NOT NULL default '0' COMMENT '收银员id',
            "customerUid",//int(10) NOT NULL default '0' COMMENT '会员id',
            "price",//decimal(10,2) NOT NULL default '0.00' COMMENT '会员id',
            "extends",//json DEFAULT NULL COMMENT '拓展字段',
            "createTime",//int(10) NOT NULL DEFAULT '0' COMMENT '创建时间',
            "updateTime",//int(10) NOT NULL DEFAULT '0' COMMENT '更新时间',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}