<?php

namespace JinDouYun\Dao\Cashier;


use JinDouYun\Dao\BaseDao;

/**
 * Description:
 * Class DCashierGuide
 * @package JinDouYun\Dao\Cashier
 */
class DCashierGuide extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'cashier_guide';
        $this->_primary = 'id';
        $this->_fields = [
            "id",//int(10) NOT NULL AUTO_INCREMENT COMMENT 'id',
            "name",//varchar(255) DEFAULT '' COMMENT '导购员姓名',
            "mobile",//char(11) DEFAULT '' COMMENT '手机号',
            "enableStatus",//tinyint(4) DEFAULT '5' COMMENT '启用状态(5启用 4禁用)',
            "deleteStatus",//tinyint(4) DEFAULT '5' COMMENT '删除状态(5未删除   4已删除)',
            "isSetRule",//tinyint(4) DEFAULT '5' COMMENT '规则状态(5启用 4不启用)',
            "rule",//json DEFAULT NULL COMMENT '自定义规则',
            "createTime",//int(10) DEFAULT '0' COMMENT '创建时间',
            "updateTime",//int(10) DEFAULT '0' COMMENT '修改时间',
            "extend",//json DEFAULT NULL COMMENT '扩展字段',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}