<?php
namespace JinDouYun\Dao\Cashier;

use JinDouYun\Dao\BaseDao;

/**
 * Description: 提成明细
 * Class DCashierPushMoneyDetail
 * @package JinDouYun\Dao\Cashier
 */
class DCashierPushMoneyDetail extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'cashier_push_money_detail';
        $this->_primary = 'id';
        $this->_fields = [
            "id",//int(10) NOT NULL AUTO_INCREMENT COMMENT 'id',
            "pushType",//tinyint(4) DEFAULT '1' COMMENT '人员类型(1收银员 2导购员)',
            "staffName",//varchar(255) DEFAULT '' COMMENT '导购/收银员姓名',
            "orderId",//int(10) DEFAULT '0' COMMENT '订单id',
            "orderNo",//varchar(50) DEFAULT '' COMMENT '订单号',
            "orderMoney",//decimal(10,2) DEFAULT '0.00' COMMENT '订单金额',
            "pushMoneyRate",//decimal(10,2) DEFAULT '0.00' COMMENT '提成',
            "pushMoney",//decimal(10,2) DEFAULT '0.00' COMMENT '提成金额',
            "deleteStatus",//tinyint(1) DEFAULT '5' COMMENT '删除状态 4:删除 5:正常',
            "auditStatus",//tinyint(1) DEFAULT '1' COMMENT '审核状态 1:未审核 2:已审核',
            "auditTime",//int(10) DEFAULT NULL COMMENT '审核时间',
            "createTime",//int(10) DEFAULT '0' COMMENT '创建时间',
            "updateTime",//int(10) DEFAULT '0' COMMENT '修改时间',
            "extend",//json DEFAULT NULL COMMENT '扩展字段',
            "shopId",
            "userCenterId",//导购/收银员id
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}