<?php

namespace JinDouYun\Dao\Cashier;

use JinDouYun\Dao\BaseDao;

/**
 * Description:
 * Class DCashierSettings
 * @package JinDouYun\Dao\Cashier
 */
class DCashierSettings extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'cashier_settings';
        $this->_primary = 'id';
        $this->_fields = [
            "id",//int(10) NOT NULL AUTO_INCREMENT COMMENT 'id',
            "enterpriseId",//int(11) NOT NULL COMMENT '企业id',
            "content",//json DEFAULT NULL COMMENT '设置数据',
            "deleteStatus",//tinyint(4) DEFAULT '5' COMMENT '删除状态(5未删除   4已删除)',
            "createTime",//int(10) DEFAULT NULL COMMENT '创建时间',
            "updateTime",//int(10) DEFAULT NULL COMMENT '修改时间',
            "extend",//json DEFAULT NULL COMMENT '扩展字段',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}