<?php

namespace JinDouYun\Dao\Commission;


use JinDouYun\Dao\BaseDao;

/**
 * Description: 佣金变动记录表
 * Class DCommissionFlow
 * @package JinDouYun\Dao\Commission
 */
class DCommissionFlow extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'commission_flow';
        $this->_primary = 'id';
        $this->_fields = [
            "id" ,//int(10) NOT NULL AUTO_INCREMENT COMMENT '佣金流水表',
            "userCenterId" ,//int(10) DEFAULT NULL,
            "customerId" ,//int(10) DEFAULT NULL COMMENT '客户id',
            "businessmanId" ,//int(10) DEFAULT NULL COMMENT '分销商id',
            "amount" ,//decimal(8,2) DEFAULT NULL COMMENT '金额',
            "changeAmount" ,//decimal(8,2) DEFAULT NULL COMMENT '变动后金额',
            "type" ,//tinyint(1) DEFAULT NULL COMMENT '状态 4:减 5:加',
            "createTime" ,//int(10) DEFAULT NULL COMMENT '创建时间',
            "updateTime" ,//int(10) DEFAULT NULL COMMENT '修改时间',
            "extend" ,//json DEFAULT NULL COMMENT '扩展字段',
            "des",//
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}