<?php


namespace JinDouYun\Dao\Commission;


use JinDouYun\Dao\BaseDao;

/**
 * Description:商品分销统计表
 * Class DCommissionGoodsStatistics
 * @package JinDouYun\Dao\Commission
 */
class DCommissionGoodsStatistics extends BaseDao
{
    /**
     * DCommissionGoodsStatistics constructor.
     * @param string $serviceDB
     */
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'commission_goods_statistics';
        $this->_primary = 'id';
        $this->_fields = [
            "id",//int(10) NOT NULL AUTO_INCREMENT,
            "goodsId",//int(10) DEFAULT '0' COMMENT '商品id',
            "skuId",//int(10) DEFAULT '0' COMMENT 'skuId',
            "salesNum",//int DEFAULT '0' COMMENT '分销商品销量',
            "commission",//decimal(10,2) DEFAULT 0.00 COMMENT '分销商品佣金',
            "extends",//json DEFAULT NULL COMMENT '拓展字段',
            "createTime",//int(10) NOT NULL DEFAULT '0' COMMENT '创建时间',
            "updateTime",//int(10) NOT NULL DEFAULT '0' COMMENT '更新时间',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}