<?php


namespace JinDouYun\Dao\Commission;

use JinDouYun\Dao\BaseDao;

/**
 * Description:
 * Class DCommissionOrderIndex
 * @package JinDouYun\Dao\Commission
 */
class DCommissionOrderIndex extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'commission_order_index';
        $this->_primary = 'id';
        $this->_fields = [
            "id",// int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '主键id',
            "userCenterId",// int(11) unsigned NOT NULL DEFAULT '0' COMMENT '用户id (买家)',
            "customerId",// int(11) unsigned NOT NULL DEFAULT '0' COMMENT '客户id (买家)',
            "orderId",// int(11) unsigned NOT NULL DEFAULT '0' COMMENT '订单id',
            "orderNo",// varchar(50) NOT NULL DEFAULT '' COMMENT '订单号',
            "payAmount",// decimal(10,2) unsigned NOT NULL DEFAULT '0.00' COMMENT '订单支付金额',
            "retUserCenterId",// int(11) unsigned NOT NULL DEFAULT '0' COMMENT '返佣用户id',
            "retCustomerId",// int(11) unsigned NOT NULL DEFAULT '0' COMMENT '返佣客户id',
            "retMoney",// decimal(10,2) unsigned NOT NULL DEFAULT '0.00' COMMENT '分销佣金',
            "retLevel",// int(11) unsigned NOT NULL DEFAULT '0' COMMENT '返佣用户级别 1,2,3',
            "retGrade",// int(11) unsigned NOT NULL DEFAULT '0' COMMENT '返佣用户等级 1-10级',
            "createTime",// int(11) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
            "updateTime",// int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
            "extends",// json DEFAULT NULL COMMENT '拓展字段',
            "isAccount",
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}