<?php
/**
 * 分销体现记录Dao
 * Created by PhpStorm.
 * User: phperstar
 * Date: 2020/07/30
 * Time: 9:00
 */

namespace JinDouYun\Dao\Commission;

use JinDouYun\Dao\BaseDao;

class DCommissionWithdrawals extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'qianniao_commission_withdrawals_1';
        $this->_primary = 'id';
        $this->_fields = [
            'id',  //int(10) NOT NULL AUTO_INCREMENT COMMENT '自增主键',
            'userCenterId',  //int(10) NOT NULL COMMENT '用户id',
            'businessmanId',  //int(10) NOT NULL COMMENT '分销商id',
            'type',  //tinyint(3) NOT NULL COMMENT '体现方式',
            'accountContent', // json DEFAULT NULL COMMENT '体现账号信息',
            'money',  //decimal(8,2) NOT NULL COMMENT '体现金额',
            'nowMoney',  //decimal(8,2) NOT NULL COMMENT '当前实际金额',
            'fee',  //decimal(8,2) NOT NULL COMMENT '体现手续费',
            'auditStatus',  //tinyint(3) NOT NULL COMMENT '审核状态',
            'auditTime', // int(10) DEFAULT '0' COMMENT '审核通过时间',
            'payTime', //int(10) DEFAULT '0' COMMENT '完成打款时间',
            'createTime',  //int(10) NOT NULL COMMENT '创建时间',
            'updateTime',  //int(10) NOT NULL COMMENT '修改时间',
            'extend',  //json DEFAULT NULL COMMENT '扩展字段',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}