<?php

namespace JinDouYun\Dao\Customer;

use JinDouYun\Dao\BaseDao;

class DCustomerCommunication extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'customer_communication';
        $this->_primary = 'id';
        $this->_fields = [
            "id", //int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
            "customerId", //int(10) DEFAULT NULL COMMENT '客户id',
            "staffId", //int(10) DEFAULT NULL COMMENT '员工id',
            "content", //varchar(255) DEFAULT NULL COMMENT '描述',
            "time", //int(10) DEFAULT NULL COMMENT '跟进时间',
            'location',//varchar(255) DEFAULT NULL COMMENT '定位',
            'picture',//mediumblob COMMENT '图片地址',
            'deleteStatus',
            "createTime", //int(10) DEFAULT NULL COMMENT '创建时间',
            "updateTime", //int(10) DEFAULT NULL COMMENT '修改时间',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}