<?php
namespace JinDouYun\Dao\Customer;

use JinDouYun\Dao\BaseDao;

class DCustomerContact extends BaseDao 
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'customer_contact';
        $this->_primary = 'id';
        $this->_fields = [
              'id',//int(11) NOT NULL AUTO_INCREMENT COMMENT '客户联系人id',
              'customerId',//int(10) NOT NULL COMMENT '客户id',
              'name',//varchar(50) NOT NULL COMMENT '联系人名称',
              'mobile',//char(11) NOT NULL COMMENT '联系人电话',
              'provinceCode',//varchar(20) NOT NULL COMMENT '联系人地址省编码',
              'cityCode',//varchar(20) NOT NULL COMMENT '联系人地址市编码',
              'districtCode',//varchar(20) NOT NULL COMMENT '联系人地址区编码',
              'address',//varchar(50) NOT NULL COMMENT '联系人详细地址',
              'deleteStatus',//tinyint(1) DEFAULT '5' COMMENT '删除状态（5未删除 4已删除）',
              'createTime',//int(10) DEFAULT NULL COMMENT '创建时间',
              'updateTime',//int(10) DEFAULT NULL COMMENT '修改时间',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}