<?php
/**
 * 客户余额充值记录Dao
 * Created by PhpStorm.
 * User: 小威
 * Date: 2020/09/12
 * Time: 11:30
 */

namespace JinDouYun\Dao\Customer;

use JinDouYun\Dao\BaseDao;

class DCustomerRechargeRecord extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'customer_recharge_record';
        $this->_primary = 'id';
        $this->_fields = [
            "id", //int(10) NOT NULL AUTO_INCREMENT COMMENT '充值记录',
            "no", //char(25) DEFAULT NULL COMMENT '单号',
            "customerId", //int(10) DEFAULT NULL COMMENT '客户id',
            "userCenterId", //int(10) DEFAULT NULL COMMENT 'userCenterId',
            "shopId", //int(10) DEFAULT NULL COMMENT '商铺id',
            "money", //decimal(8,2) DEFAULT NULL COMMENT '充值金额',
            "balance", //decimal(8,2) DEFAULT NULL COMMENT '充值后余额',
            "desc", //varchar(255) DEFAULT NULL COMMENT '文字描述',
            "payStatus", //tinyint(1) DEFAULT '4' COMMENT '支付状态 4:未完成 5:已完成',
            "createTime", //int(10) DEFAULT NULL COMMENT '创建时间',
            "updateTime", //int(10) DEFAULT NULL COMMENT '修改时间',
            "extend", //json DEFAULT NULL COMMENT '扩展字段',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}