<?php

namespace JinDouYun\Dao\Customer;

use JinDouYun\Dao\BaseDao;

class DCustomerTagLib extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'customer_taglib';
        $this->_primary = 'id';
        $this->_fields = [
            'id',  //int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
            'enterpriseId',  //int(10) NOT NULL COMMENT '企业id',
            'name',  //char(255) NOT NULL DEFAULT '' COMMENT '标签名/标签组名',
            'pid',  //int(10) NOT NULL DEFAULT '0' COMMENT '归属组id',
            'colour',  //tinyint(125) NOT NULL DEFAULT '0' COMMENT '颜色标识',
            'mustValue',  //tinyint(125) NOT NULL DEFAULT '4' COMMENT '是否必填',
            'createTime',  //int(10) DEFAULT NULL COMMENT '创建时间',
            'updateTime',  //int(10) DEFAULT NULL COMMENT '修改时间',
            'extend',  //json DEFAULT NULL COMMENT '扩展字段',
            'deleteStatus'
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}