<?php
/**
 * 客户收货地址管理Dao
 * Created by PhpStorm.
 * User: 小威
 * Date: 2019/10/31
 * Time: 11:30
 */

namespace JinDouYun\Dao\Customer;

use JinDouYun\Dao\BaseDao;

class DShippingAddress extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'customer_shipping_address';
        $this->_primary = 'id';
        $this->_fields = [
            "id", //int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
            "customerId", //int(10) NOT NULL COMMENT '客户id',
            "customerCode", //varchar(50) NOT NULL COMMENT '客户编码',
            "name", //varchar(30) DEFAULT NULL COMMENT '客户收货姓名',
            "mobile", //char(11) DEFAULT NULL COMMENT '客户收货手机号',
            "provinceCode", //varchar(50) DEFAULT NULL COMMENT '客户收货地址省份编码',
            "cityCode", //varchar(50) DEFAULT NULL COMMENT '客户收货地址城市编码',
            "districtCode", //varchar(50) DEFAULT NULL COMMENT '客户收货地址区县编码',
            "address", // varchar(255) DEFAULT NULL COMMENT '详细收货地址',
            "defaultStatus", //tinyint(3) NOT NULL DEFAULT '5' COMMENT '默认状态 5:默认 4:不是默认',
            "deleteStatus", //tinyint(3) NOT NULL DEFAULT '5' COMMENT '删除状态 5:正常 4:删除',
            "createTime", //int(10) NOT NULL COMMENT '创建时间',
            "updateTime", //int(10) NOT NULL COMMENT '修改时间',
            "extend", //json DEFAULT NULL COMMENT '扩展字段',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}