<?php
/**
 * Created by PhpStorm.
 * User: kang
 * Date: 2021/5/26
 * Time: 19:45
 */
namespace JinDouYun\Dao\Delivery;

use JinDouYun\Dao\BaseDao;

class DDeliveryDetails extends BaseDao
{
    public function __construct($serviceDB = 'stock')
    {
        $this->_table = 'delivery_details';
        $this->_primary = 'id';
        $this->_fields = [
                    'id' ,//int(10) NOT NULL AUTO_INCREMENT COMMENT '配送明细id',
                    'linkeId' ,//int(10) NOT NULL COMMENT '主单据表id',
                    'deliveryDate' ,//varchar(255) NOT NULL COMMENT '单据日期',
                    'TaskNo' ,//varchar(255) NOT NULL COMMENT '单据编号',
                    "deliveryStatus" ,//int(11) NOT NULL DEFAULT '1' COMMENT '配送状态（1：待配送 2：已配送3：配送中）',
                    'sourceNo' ,//varchar(255) NOT NULL COMMENT '来源单号',
                    'customerId' ,//tinyint(255) NOT NULL COMMENT '客户id',
                    'customerName' ,//varchar(255) NOT NULL COMMENT '客户名称',
                    'manager' ,//varchar(255) NOT NULL COMMENT '经手人',
                    'receiver' ,//varchar(255) NOT NULL COMMENT '收货人',
                    'mobile' ,//varchar(255) NOT NULL COMMENT '联系电话',
                    'receivingAddress' ,//varchar(255) DEFAULT NULL COMMENT '收货地址',
                    'distributionRoute' ,//varchar(255) DEFAULT NULL COMMENT '配送线路',
                    'deliveryOrder' ,//varchar(255) DEFAULT NULL COMMENT '配送顺序',
                    'deliveryWarehouseId' ,//int(11) NOT NULL COMMENT '发货仓库id',
                    'binningNum' ,//varchar(255) NOT NULL COMMENT '装箱数量',
                    'deliveryQuantity' ,//varchar(255) NOT NULL COMMENT '发货数量',
                    'returnWarehouse' ,//varchar(255) NOT NULL COMMENT '退货仓库',
                    'returnGoodsNum' ,//varchar(255) DEFAULT NULL COMMENT '退货数量',
                    'containerLocation' ,//varchar(255) DEFAULT NULL COMMENT '集货位',
                    'estimateDeliveryDate' ,//varchar(255) DEFAULT NULL COMMENT '预计发货日期',
                    'remark' ,//varchar(255) DEFAULT NULL COMMENT '备注',
                    'deleteStatus' ,//tinyint(11) NOT NULL DEFAULT '5' COMMENT '是否删除 4 删除 5正常',
                    'createTime' ,//varchar(255) NOT NULL COMMENT '创建时间',
                    'updateTime' ,//varchar(255) DEFAULT NULL COMMENT '修改时间',
                    'extends' ,//json DEFAULT NULL COMMENT '扩展字段',
                    'enterpriseId' ,//int(10) unsigned zerofill NOT NULL DEFAULT '0000000000' COMMENT '企业id',
                    "driverId",// int(10) DEFAULT NULL COMMENT '司机id',
                    "driverName",// varchar(255) DEFAULT NULL COMMENT '司机名称',
                    "carId",// int(10) DEFAULT NULL COMMENT '车辆id',
                    "deliveryCar",// varchar(255) DEFAULT NULL COMMENT '车辆名称',
                    'deliveryOrderNum' ,//varchar(255) DEFAULT NULL COMMENT '送货数量',
                    'returnGoodsOrderNum' ,//varchar(255) DEFAULT NULL COMMENT '退货数量',
                    'deliverGoodsQuantity' ,//varchar(255) DEFAULT NULL COMMENT '发货数量',
                    'deliveryAmount' ,//varchar(255) DEFAULT NULL COMMENT '发货金额',
                    'signedQuantity' ,//varchar(255) DEFAULT NULL COMMENT '签收数量',
                    'signedAmount' ,//varchar(255) DEFAULT NULL COMMENT '签收金额',
                    'rejectionQuantity' ,//varchar(255) DEFAULT NULL COMMENT '拒收数量',
                    'rejectionAmount' ,//varchar(255) DEFAULT NULL COMMENT '拒收金额',
                    'deliveryMileage' ,//varchar(255) DEFAULT NULL COMMENT '配送里程',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];
        
        parent::__construct($serviceDB);
    }
}