<?php
/**
 * 配送线路Dao
 * Created by PhpStorm.
 * User: haoren
 * Date: 2021/04/20
 * Time: 16:00
 */

namespace JinDouYun\Dao\Delivery;

use JinDouYun\Dao\BaseDao;

class DDeliveryRoute extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'delivery_route';
        $this->_primary = 'id';
        $this->_fields = [
            "id", //int(10) NOT NULL AUTO_INCREMENT COMMENT '线路表',
            "name", //varchar(255) DEFAULT NULL COMMENT '线路名称',
            "shopId", //int(10) DEFAULT '0' COMMENT '商铺id',
            "warehouseId", //int(10) DEFAULT '0' COMMENT '仓库id',
            "driverId", //varchar(255) DEFAULT NULL COMMENT '司机id ,分割',
            "desc", //varchar(255) DEFAULT NULL COMMENT '备注,描述',
            "enableStatus", //tinyint(1) DEFAULT '5' COMMENT '启用状态 4:禁用 5:正常',
            "deleteStatus", //tinyint(1) DEFAULT '5' COMMENT '删除状态 4:删除 5:正常',
            "createTime", //int(10) DEFAULT NULL COMMENT '创建时间',
            "updateTime", //int(10) DEFAULT NULL COMMENT '修改时间',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}