<?php
/**
* Created by PhpStorm.
* User: kang
* Date: 2021/5/26
* Time: 14:31
*/
namespace JinDouYun\Dao\Delivery;

use JinDouYun\Dao\BaseDao;

class DDeliveryTask extends BaseDao
{
    public function __construct($serviceDB = 'stock')
    {
        $this->_table = 'delivery_task';
        $this->_primary = 'id';
        $this->_fields = [
            'id' , //int(10) NOT NULL AUTO_INCREMENT COMMENT '配送任务id',
            'deliveryDate' , //varchar(255) NOT NULL COMMENT '指定配送日期',
            'TaskNo' , //varchar(255) NOT NULL COMMENT '任务编号',
            'sourceNo' ,//varchar(255) DEFAULT NULL COMMENT '来源订单号',
            'deliveryStatus' , //tinyint(11) NOT NULL COMMENT '配送状态（1:待配送，2已配送）',
            'deliveryStartTime' , //varchar(255) NOT NULL COMMENT '配送开始时间',
            'deliveryEndTime' , //varchar(255) DEFAULT NULL COMMENT '配送结束时间',
            'driverId' , //tinyint(11) NOT NULL COMMENT '司机Id',
            'driverName' , //varchar(255) NOT NULL COMMENT '司机名称',
            'carId' , //int(11) DEFAULT NULL COMMENT '配送车辆id',
            'deliveryCar' , //varchar(255) DEFAULT NULL COMMENT '配送车辆',
            'deliveryBoyId' , //int(11) DEFAULT NULL COMMENT '送货员id',
            'deliveryBoy' , //varchar(255) DEFAULT NULL COMMENT '送货员',
            'deliveryOrderNum' , //varchar(255) DEFAULT NULL COMMENT '配送单量',
            'returnGoodsOrderNum' , //varchar(255) DEFAULT NULL COMMENT '退货单量',
            'deliverGoodsQuantity' , //varchar(255) DEFAULT NULL COMMENT '发货数量',
            'deliveryAmount' , //varchar(255) NOT NULL DEFAULT '0' COMMENT '发货金额',
            'signedQuantity' , //varchar(255) NOT NULL COMMENT '签收数量',
            'signedAmount' , //varchar(255) NOT NULL COMMENT '签收金额',
            'rejectionQuantity' , //varchar(255) DEFAULT NULL COMMENT '拒收数量',
            'rejectionAmount' , //varchar(255) DEFAULT NULL COMMENT '拒收金额',
            'returnGoodsQuantity' , //varchar(255) DEFAULT NULL COMMENT '退货数量',
            'returnGoodsAmount' , //varchar(255) DEFAULT NULL COMMENT '退货金额',
            'binningQuantity' , //varchar(255) DEFAULT NULL COMMENT '装箱数量',
            'deliveryMileage' , //varchar(255) DEFAULT NULL COMMENT '配送里程',
            'remark' , //varchar(255) DEFAULT NULL COMMENT '备注',
            'createTime' , //varchar(255) NOT NULL COMMENT '创建时间',
            'updateTime' , //varchar(255) DEFAULT NULL COMMENT '结束时间',
            'extends' , //json DEFAULT NULL COMMENT '扩展字段',
            'enterpriseId' , //int(11) NOT NULL COMMENT '企业id',
            'deleteStatus' , //tinyint(11) NOT NULL DEFAULT '5' COMMENT '删除状态 5:正常 4:删除',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];
        
        parent::__construct($serviceDB);
    }
}