<?php
/**
* Created by PhpStorm.
* User: kang
* Date: 2021/5/26
* Time: 9:50
*/
namespace JinDouYun\Dao\Delivery;

use JinDouYun\Dao\BaseDao;

class DDistributionCentre extends BaseDao
{
    public function __construct($serviceDB = 'stock')
    {
        $this->_table = 'delivery_centre';
        $this->_primary = 'id';
        $this->_fields = [
                'id' , //int(10) NOT NULL AUTO_INCREMENT COMMENT '主单据id',
                'documentDate' , //varchar(255) NOT NULL COMMENT '单据日期',
                'documentNo' , //varchar(255) NOT NULL COMMENT '单据编号',
                'sourceNo' , //varchar(255) NOT NULL COMMENT '来源订单',
                'deliveryState' , //int(11) NOT NULL COMMENT '配送状态（1:待分配，2已分配）',
                'documentType' , //int(11) NOT NULL COMMENT '单据类型（）',
                'customerId',// int(11) NOT NULL COMMENT '客户id',
                'customerName' , //varchar(255) NOT NULL COMMENT '客户名称',
                'warehouseId',//int(255) NOT NULL COMMENT '仓库id',
                'deliveryWarehouse',// varchar(255) NOT NULL COMMENT '发货仓库',
                'deliveryQuantity' , //varchar(255) NOT NULL COMMENT '发货数量',
                'deliveryAmount' , //varchar(255) NOT NULL COMMENT '发货金额',
                'returnGoodsNum' ,// varchar(255) DEFAULT '0' COMMENT '退货数量',
                'returnWarehouse' , //varchar(255) NOT NULL COMMENT '退货仓库',
                'returnAmount' , //varchar(255) NOT NULL COMMENT '退货金额',
                'containerLocation' , //varchar(255) NOT NULL DEFAULT '0' COMMENT '集货位',
                'binningNum' , //varchar(255) NOT NULL DEFAULT '0' COMMENT '装箱数量',
                'packingNum' , //varchar(255) DEFAULT NULL COMMENT '包装数量（123）',
                'manager' , //varchar(255) NOT NULL COMMENT '经手人',
                'producer' , //varchar(255) NOT NULL COMMENT '制单人',
                'receiver' , //varchar(255) NOT NULL COMMENT '收货人',
                'mobile' , //char(255) NOT NULL COMMENT '联系电话',
                'receivingAddress' , //varchar(255) NOT NULL COMMENT '收货地址',
                'distributionRoute' , //varchar(255) NOT NULL COMMENT '配送线路',
                'expectedDelivery' , //varchar(255) NOT NULL COMMENT '预计发货',
                'modeOfProduction' , //varchar(255) NOT NULL COMMENT '产生方式',
                'driverId', // int(11) DEFAULT NULL COMMENT '司机id',
                'distributionDriver' , //varchar(255) NOT NULL COMMENT '配送司机',
                'remarks' , //varchar(255) NOT NULL COMMENT '备注',
                'deleteStatus' , //tinyint(10) NOT NULL DEFAULT '5' COMMENT '是否删除 4 删除 5正常',
                'createTime' , //varchar(255) NOT NULL COMMENT '创建时间',
                'updateTime' , //varchar(255) DEFAULT NULL COMMENT '修改时间',
                'extends' , //json DEFAULT NULL COMMENT '扩展字段',
                'enterpriseId' , //int(11) NOT NULL COMMENT '企业id',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];
        
        parent::__construct($serviceDB);
    }
}