<?php
/**
 * 员工提成流水Dao
 * Created by PhpStorm.
 * User: haoren
 * Date: 2021/03/25
 * Time: 15:00
 */

namespace JinDouYun\Dao\Department;

use JinDouYun\Dao\BaseDao;

class DStaffRewardDesc extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'staff_reward_desc';
        $this->_primary = 'id';
        $this->_fields = [
            "id", //int(10) NOT NULL AUTO_INCREMENT COMMENT '流水表',
            "userCenterId", //int(10) DEFAULT NULL COMMENT '用户id',
            "customerId", //int(10) DEFAULT NULL COMMENT '客户id',
            "staffId", //int(10) DEFAULT NULL COMMENT '员工id',
            "shopId", //int(10) DEFAULT '0' COMMENT '商铺id',
            "ruleId", //int(10) DEFAULT NULL COMMENT '规则id',
            "originId", //int(10) DEFAULT '0' COMMENT '来源id',
            "originNo", //varchar(255) DEFAULT NULL COMMENT '来源单号',
            "title", //varchar(255) DEFAULT NULL COMMENT '说明',
            "amount", //decimal(8,2) DEFAULT NULL COMMENT '金额',
            "changeAmount", //decimal(8,2) DEFAULT NULL COMMENT '变动后金额',
            "type", //tinyint(1) DEFAULT NULL COMMENT '状态 4:减 5:加',
            "source", //tinyint(1) DEFAULT NULL COMMENT '来源 1:订单金额满足 2:购买指定商品 3:后台手动修改',
            "createTime", //int(10) DEFAULT NULL COMMENT '创建时间',
            "updateTime", //int(10) DEFAULT NULL COMMENT '修改时间',
            "extend", //json DEFAULT NULL COMMENT '扩展字段',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}