<?php
/**
 * 企业管理Dao
 * Created by PhpStorm.
 * User: 小威
 * Date: 2019/11/04
 * Time: 11:50
 */

namespace JinDouYun\Dao\Enterprise;

use JinDouYun\Dao\BaseDao;

class DEnterprise extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'enterprise';
        $this->_primary = 'id';
        $this->_fields = [
            "id", //int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
            "userCenterId", //int(11) DEFAULT NULL COMMENT '客户id',
            "brandName", //varchar(50) DEFAULT NULL COMMENT '品牌名称',
            "enterpriseName", //varchar(50) DEFAULT NULL COMMENT '企业名称',
            "contact", //varchar(30) DEFAULT NULL COMMENT '联系人',
            "mobile", //varchar(20) DEFAULT NULL COMMENT '联系电话',
            "provinceCode", //varchar(50) DEFAULT NULL COMMENT '省份编码',
            "cityCode", //varchar(50) DEFAULT NULL COMMENT '城市编码',
            "districtCode", //varchar(50) DEFAULT NULL COMMENT '区县编码',
            "address", //varchar(255) DEFAULT NULL COMMENT '详细地址',
            "categoryId", //int(10) DEFAULT NULL COMMENT '企业类别',
            "startTime", //int(10) DEFAULT NULL COMMENT '营业时间',
            "endTime", //int(10) DEFAULT NULL COMMENT '停业时间',
            "logo", //varchar(255) DEFAULT NULL COMMENT '企业logo',
            "appid", //varchar(50) DEFAULT NULL COMMENT 'appid',
            "appSecret", //char(32) DEFAULT NULL COMMENT 'appSecret',
            "token", //char(32) DEFAULT NULL COMMENT 'token',
            "deleteStatus", //tinyint(3) DEFAULT '5' COMMENT '删除状态  4:删除 5:正常 6:过期',
            "createTime", //int(10) DEFAULT NULL COMMENT '创建时间',
            "updateTime", //int(10) DEFAULT NULL COMMENT '更新时间',
            "extend", //json DEFAULT NULL COMMENT '扩展字段',
            "scope", //tinyint(3) DEFAULT '5' COMMENT '删除状态  4:单店铺 5:多店铺（默认）',
            "iosAuditStatus",//tinyint(3) DEFAULT '5' COMMENT '删除状态  4:审核中 5:正常（默认）',
            "balance",//余额
            "isoem", //tinyint(3) NOT NULL DEFAULT '4' COMMENT 确认企业贴牌 4是确认，5是其他
            "oemId",//oem表企业id
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}