<?php
/**
 * 用户中心绑定企业管理Dao
 * Created by PhpStorm.
 * User: 小威
 * Date: 2019/11/05
 * Time: 11:00
 */

namespace JinDouYun\Dao\Enterprise;

use JinDouYun\Dao\BaseDao;

class DUserBindEnterprise extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'user_bind_enterprise';
        $this->_primary = 'id';
        $this->_fields = [
            "id", //int(10) NOT NULL AUTO_INCREMENT COMMENT '主键id',
            "userCenterId", //int(10) NOT NULL COMMENT '用户中心id',
            "enterpriseId", //int(10) NOT NULL COMMENT '企业id',
            "roleType", //tinyint(3) DEFAULT '2' COMMENT '角色类型',
            "shopId", //int(10) DEFAULT '0' COMMENT '商铺id',
            "merchantId", //int(10) DEFAULT '0' COMMENT '商户id',
            "updateTime", //int(10) NOT NULL COMMENT '更新时间',
            "createTime", //int(10) NOT NULL COMMENT '创建时间',
            "extend", //json DEFAULT NULL COMMENT '扩展字段',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}