<?php
/**
 * Created by PhpStorm.
 * User: wxj
 * Date: 2019/10/30
 * Time: 14:17
 */
namespace JinDouYun\Dao\Finance;

use JinDouYun\Dao\BaseDao;

class DAccount extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = "account";
        $this->_primary = 'id';
        $this->_fields = [
              'id',//int(11) NOT NULL AUTO_INCREMENT COMMENT '账户id',
              'enterpriseId',//int(11) DEFAULT NULL COMMENT '企业id',
              'name',//varchar(255) NOT NULL COMMENT '账户名称',
              'accountCode',//varchar(255) DEFAULT NULL COMMENT '账户编号',
              'accountNumber',//varchar(255) NOT NULL COMMENT '账户号',
              'beginMoney',//float(10,2) NOT NULL DEFAULT '0.00' COMMENT '期初余额',
              'shopId',//int(11) NOT NULL COMMENT '商铺id',
              'shopName',// varchar(50) DEFAULT NULL COMMENT '商铺名称',
              'enableStatus',//tinyint(1) NOT NULL DEFAULT '4' COMMENT '启用状态(5启用 4禁用)',
              'money',//float(10,2) NOT NULL DEFAULT '0.00' COMMENT '当前余额',
              'createTime',//int(11) DEFAULT NULL COMMENT '创建日期',
              'updateTime',//int(11) DEFAULT NULL COMMENT '修改日期',
              'remark',//text COMMENT '备注',
              'extends',//json DEFAULT NULL COMMENT '扩展字段',
              'deleteStatus',// tinyint(1) DEFAULT '5' COMMENT '删除(5未删除  4已删除)',
              'isDefault',
              'type',
              'bankName',
              'bankAccount'
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}