<?php
/**
 * Created by PhpStorm.
 * User: wxj
 * Date: 2019/10/30
 * Time: 14:17
 */

namespace JinDouYun\Dao\Finance;

use JinDouYun\Dao\BaseDao;

class DAccountDetail extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'qianniao_account_detail_1';
        $this->_primary = 'id';
        $this->_fields = [
            'id',//int(11) NOT NULL AUTO_INCREMENT COMMENT '账户明细表id',
            'accountId',// int(11) DEFAULT NULL COMMENT '账户id',
            'accountCode',//varchar(255) DEFAULT NULL COMMENT '账户编号',
            'accountName',//varchar(255) DEFAULT NULL COMMENT '账户名称',
            'accountNumber',//varbinary(255) DEFAULT NULL COMMENT '账户号',
            'sourceNo',//char(25) DEFAULT NULL COMMENT '来源单据编号',
            'sourceId',//char(25) DEFAULT NULL COMMENT '来源单据id',
            'financeType',//varchar(50) DEFAULT NULL COMMENT '业务类型',
            'beginBalance',//decimal(15,4) DEFAULT NULL COMMENT '期初余额',
            'shopId',//int(11) DEFAULT NULL COMMENT '所属商铺',
            'shopName',//varchar(50) DEFAULT NULL COMMENT '商铺名称',
            'income',//decimal(15,4) DEFAULT NULL COMMENT '收入',
            'expend',//decimal(15,4) DEFAULT NULL COMMENT '支出',
            'endBalance',//decimal(15,4) DEFAULT NULL COMMENT '账户余额',
            'contactUnit',//varchar(255) DEFAULT NULL COMMENT '往来单位名称',
            'supplierId',//int(11) DEFAULT NULL COMMENT '供应商id',
            'customerId',//int(11) DEFAULT NULL COMMENT '客户id',
            'operatorId',//int(11) DEFAULT NULL COMMENT '操作人Id',
            'receiveOrPayPerson',//varchar(255) DEFAULT NULL COMMENT '收/付款人',
            'remark',//text COMMENT '备注',
            'createTime',//int(11) DEFAULT NULL COMMENT '创建时间',
            'updateTime',//int(11) DEFAULT NULL COMMENT '修改时间',
            'extends',//json DEFAULT NULL COMMENT '扩展字段',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}