<?php
/**
 * Created by PhpStorm.
 * User: wxj
 * Date: 2019/10/30
 * Time: 14:17
 */

namespace JinDouYun\Dao\Finance;

use JinDouYun\Dao\BaseDao;

class DCustomerBalanceDetail extends BaseDao
{
    public function __construct($serviceDB = 'finance')
    {
        $this->_table = 'qianniao_customer_balance_detail_1';
        $this->_primary = 'id';
        $this->_fields = [
            'id', //int(11) NOT NULL AUTO_INCREMENT COMMENT '客户余额明细表',
            'customerId', //int(11) DEFAULT NULL COMMENT '客户id',
            'receiptTime', //int(11) DEFAULT NULL COMMENT '单据日期',
            'sourceId', //int(10) DEFAULT '0' COMMENT '来源id',
            'sourceNo', //char(25) DEFAULT NULL COMMENT '来源编号',
            'financeType', //varchar(255) DEFAULT NULL COMMENT '财务类型名称',
            'financeTypeId', //int(11) DEFAULT NULL COMMENT '财务类型id',
            'originNo', //char(15) DEFAULT NULL COMMENT '原始单据编号',
            'originId', //int(10) DEFAULT '0' COMMENT '原始单据id',
            'salesAmount', //decimal(15,4) DEFAULT NULL COMMENT '销售金额',
            'discountMoney', //decimal(15,4) DEFAULT NULL COMMENT '优惠金额',
            'customerAmount', //decimal(15,4) DEFAULT NULL COMMENT '客户承担金额',
            'receivableAmount', //decimal(15,4) DEFAULT NULL COMMENT '应收金额',
            'actualReceivableAmount', //decimal(15,4) DEFAULT NULL COMMENT '实际收款金额',
            'refundMoney', //decimal(15,4) DEFAULT '0.0000' COMMENT '实际退款金额',
            'receivableBalance', //decimal(15,4) DEFAULT NULL COMMENT '应收款余额',
            'remark', //text COMMENT '备注',
            'createTime', //int(11) DEFAULT NULL COMMENT '创建日期',
            'updateTime', //int(11) DEFAULT NULL COMMENT '修改日期',
            'extends', //json DEFAULT NULL COMMENT '扩展字段',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}