<?php
namespace JinDouYun\Dao\Finance;

use JinDouYun\Dao\BaseDao;

class DFinanceType extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'finance_type';
        $this->_primary = 'id';
        $this->_fields = [
          'id',//int(11) NOT NULL AUTO_INCREMENT COMMENT '财务类型Id',
          'enterpriseId',//int(11) DEFAULT NULL COMMENT '企业id',
          'link',//tinyint(1) DEFAULT NULL COMMENT '归属单据(1应收单 2应付单)',
          'name',//varchar(50) DEFAULT NULL COMMENT '财务类型名称',
          'isDefault',//tinyint(1) DEFAULT '4' COMMENT '是否默认（5默认 4非默认）',
          'enableStatus',//tinyint(1) DEFAULT '5' COMMENT '是否启用（5启用 4禁用）',
          'deleteStatus',//tinyint(1) DEFAULT NULL COMMENT '是否删除（5未删除）',
          'createTime',//int(11) DEFAULT NULL COMMENT '创建时间',
          'updateTime',//int(11) DEFAULT NULL COMMENT '修改时间',
          'extends',//json DEFAULT NULL COMMENT '扩展字段',
          'isSystem',//tinyint(1) DEFAULT '4' COMMENT '是否系统默认',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}