<?php


namespace JinDouYun\Dao\Finance;


use JinDouYun\Dao\BaseDao;

/**
 * @copyright   Copyright (c) https://www.qianniaovip.com All rights reserved
 * Description:商户资金变动记录表
 * Class DMerchantFlow
 * @package JinDouYun\Dao\Finance
 */
class DMerchantFlow extends BaseDao
{
    public function __construct($serviceDB = 'finance')
    {
        $this->_table = "merchant_flow";
        $this->_primary = 'id';
        $this->_fields = [
            "id",//int(11) NOT NULL AUTO_INCREMENT,
            "no",//varchar(30) DEFAULT NULL COMMENT '流水号',
            "merchantId",//int(10) DEFAULT NULL COMMENT '商户Id',
            "merchantName",//varchar(30) DEFAULT NULL COMMENT '商户名称',
            "shopId",//int(10) DEFAULT NULL COMMENT '店铺Id',
            "shopName",//varchar(30) DEFAULT NULL COMMENT '店铺名称',
            "originId",//int(10) DEFAULT NULL COMMENT '原单据id',
            "originNo",//varchar(30) DEFAULT NULL COMMENT '原始单号',
            "tradeMoney",//decimal(10,2) NOT NULL COMMENT '流水金额 eg: 支付100元 提现100元',
            "payType",//tinyint(3) NOT NULL DEFAULT '0' COMMENT '支付方式',
            "originMoney",//decimal(10,2) NOT NULL COMMENT '原金额',
            "changeMoney",//decimal(10,2) NOT NULL COMMENT '变动金额',
            "nowMoney",//decimal(10,2) NOT NULL COMMENT '变动后金额',
            "rate",//decimal(10,4) DEFAULT NULL COMMENT '抽成比率 eg: 0.006% (0.006)',
            "fee",//decimal(10,2) DEFAULT NULL COMMENT '抽成金额',
            "type",//tinyint(3) DEFAULT '5' COMMENT '5加 4减',
            "isPayment",//tinyint(3) DEFAULT '4' COMMENT '是否是第三方支付手续费 5是 4否',
            "isPlatform",//tinyint(3) DEFAULT '4' COMMENT '记录类型 4 商户 5 平台',
            "source",//tinyint(3) DEFAULT '1' COMMENT '1支付结算 2提现',
            "describe",//varchar(50) DEFAULT NULL COMMENT '描述',
            "createTime",//int(10) NOT NULL DEFAULT '0' COMMENT '创建时间',
            "updateTime",//int(10) NOT NULL DEFAULT '0' COMMENT '更新时间',
            "extends",//json DEFAULT NULL COMMENT '拓展字段',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}