<?php
/**
 * Created by PhpStorm.
 * User: wxj
 * Date: 2019/10/30
 * Time: 14:17
 */

namespace JinDouYun\Dao\Finance;

use JinDouYun\Dao\BaseDao;

class DPaid extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'qianniao_paid_1';
        $this->_primary = 'id';
        $this->_fields = [
            'id',//int(11) NOT NULL AUTO_INCREMENT COMMENT '付款单单索引表id',
            'no',//char(25) DEFAULT NULL COMMENT '付款单据编号',
            'auditStatus',//tinyint(1) NOT NULL DEFAULT '1' COMMENT '审核状态',
            'supplierId',//int(11) DEFAULT NULL COMMENT '供应商id',
            'supplierName',//varchar(50) DEFAULT NULL COMMENT '供应商名称',
            'sourceNo',//varchar(50) DEFAULT NULL COMMENT '源单据号',
            'currentAccountName',//varchar(50) NOT NULL COMMENT '往来账户人',
            'financeType',//varchar(50) NOT NULL COMMENT '财务类型名称',
            'financeTypeId',//int(10) DEFAULT NULL COMMENT '财务类型Id',
            'shopId',//int(11) DEFAULT NULL COMMENT '所属商铺',
            'shopName',//varchar(255) DEFAULT NULL COMMENT '商铺名称',
            'totalMoney',//float(10,2) DEFAULT NULL COMMENT '总金额',
            'totalDiscountMoney',//float(10,2) DEFAULT NULL COMMENT '总优惠金额',
            'totalFinalMoney',//float(10,2) DEFAULT NULL COMMENT '总实际付款金额',
            'offsetMoney',// decimal(15,2) DEFAULT '0.00' COMMENT '核销金额',
          'notOffsetMoney',// decimal(15,2) DEFAULT '0.00' COMMENT '未核销金额',
          'offsetStatus',// tinyint(1) DEFAULT '4' COMMENT '核销状态  5已核销/4未核销/3部分核销',
            'operatorId',//int(11) NOT NULL COMMENT '操作人员id',
            'paidType',// int(10) unsigned NOT NULL DEFAULT '4' COMMENT '付款类型',
            'receiptTime',//int(11) DEFAULT NULL COMMENT '单据日期',
            'createTime',//int(11) NOT NULL COMMENT '创建时间(单据日期)',
            'updateTime',//int(11) NOT NULL COMMENT '修改时间',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}