<?php
/**
 * Created by PhpStorm.
 * User: wxj
 * Date: 2019/10/30
 * Time: 14:17
 */

namespace JinDouYun\Dao\Finance;

use JinDouYun\Dao\BaseDao;

class DPaidIndex extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'qianniao_paid_index_1';
        $this->_primary = 'id';
        $this->_fields = [
            'id',//int(11) NOT NULL AUTO_INCREMENT COMMENT '付款单索引表id',
            'no',//char(25) DEFAULT NULL COMMENT '付款单据编号',
            'paidId',//int(11) NOT NULL COMMENT '付款单id',
            'receiptTime',//int(11) DEFAULT NULL COMMENT '单据时间',
            'createTime',//int(11) NOT NULL COMMENT '创建时间',
            'updateTime',//int(11) NOT NULL COMMENT '修改时间',
            'supplierId',//int(11) DEFAULT NULL COMMENT '往来单位',
            'currentAccountName',//varchar(50) DEFAULT NULL COMMENT '往来账户人',
            'sourceNo',//varchar(50) DEFAULT NULL COMMENT '源单据号',
            'financeType',//varchar(50) DEFAULT NULL COMMENT '财务类型',
            'financeTypeId',//int(2) DEFAULT NULL COMMENT '财务类型id',
            'auditStatus',//tinyint(1) DEFAULT NULL COMMENT '审核状态',
            'paidType',// int(10) unsigned NOT NULL DEFAULT '4' COMMENT '付款类型',
            'offsetStatus',// tinyint(1) DEFAULT '4' COMMENT '核销状态',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}