<?php

namespace JinDouYun\Dao\Finance;

use JinDouYun\Dao\BaseDao;

class DPay extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'qianniao_pay_receipt_1_201901';
        $this->_primary = 'id';
        $this->_fields = [
            'id',//int(11) NOT NULL AUTO_INCREMENT COMMENT '应付单据id',
              'supplierId',//int(11) DEFAULT NULL COMMENT '供应商Id',
              'supplierName',//varchar(50) DEFAULT NULL COMMENT '供应商名称',
              'no',//char(25) DEFAULT NULL COMMENT '应付单据编号',
              'purchaseId',//int(10) DEFAULT NULL COMMENT '采购单id',
              'sourceNo',//char(25) DEFAULT NULL COMMENT '源订单号',
              'financeTypeId',//int(10) DEFAULT NULL COMMENT '财务类型id',
              'financeType',//varchar(50) DEFAULT NULL COMMENT '财务类型名称',
              'discountMoney',//decimal(15,4) DEFAULT NULL COMMENT '优惠金额',
              'payMoney',//decimal(15,4) DEFAULT NULL COMMENT '实际应付金额',
              'warehouseId',//int(11) DEFAULT NULL COMMENT '仓库Id',
              'warehouseName',//varchar(50) DEFAULT NULL COMMENT '仓库名称',
              'deleteStatus',//tinyint(1) DEFAULT '5' COMMENT '删除状态',
              'auditStatus',//tinyint(1) NOT NULL COMMENT '审核状态(1未审核  2已审核)',
              'offsetMoney',//decimal(15,4) DEFAULT '0.0000' COMMENT '核销金额',
              'notOffsetMoney',//decimal(15,4) DEFAULT '0.0000' COMMENT '未核销金额',
              'offsetStatus',//int(10) DEFAULT '4' COMMENT '核销状态 5全部核销/4部分核销',
              'receiptTypeId',//tinyint(2) DEFAULT NULL COMMENT '单据类型Id',
              'createTime',//int(11) DEFAULT NULL COMMENT '创建时间',
              'updateTime',//int(11) DEFAULT NULL COMMENT '修改时间',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}