<?php

namespace JinDouYun\Dao\Finance;

use JinDouYun\Dao\BaseDao;

class DReceive extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'qianniao_receive_receipt_1';
        $this->_primary = 'id';
        $this->_fields = [
            'id',//int(11) NOT NULL COMMENT '应收单据id',
  'customerId',//int(11) DEFAULT NULL COMMENT '客户Id',
  'customerName',//varchar(50) DEFAULT NULL COMMENT '客户名称',
  'no',//char(25) DEFAULT NULL COMMENT '应收单据编号',
  'originId',//int(11) DEFAULT '0' COMMENT '订单id',
  'sourceNo',//char(25) DEFAULT NULL COMMENT '原单号No',
  'originNo',//char(50) DEFAULT NULL COMMENT '订单no',
  'sourceId',//int(11) DEFAULT NULL COMMENT '原单号id',
  'createTime',//int(11) DEFAULT NULL COMMENT '创建时间',
  'updateTime',//int(11) DEFAULT NULL COMMENT '修改时间',
  'financeTypeId',//int(10) DEFAULT NULL COMMENT '财务类型id',
  'financeType',//varchar(255) DEFAULT NULL COMMENT '财务类型名称',
  'discountMoney',//decimal(15,4) DEFAULT NULL COMMENT '优惠金额',
  'receiveMoney',//decimal(15,4) DEFAULT NULL COMMENT '实际应收金额',
  'shopId',//int(11) DEFAULT NULL COMMENT '商铺Id',
  'shopName',//varchar(50) DEFAULT NULL COMMENT '商铺名称',
  'offsetMoney',//decimal(15,4) DEFAULT '0.0000' COMMENT '核销金额',
  'notOffsetMoney',//decimal(15,4) DEFAULT '0.0000' COMMENT '未核销金额',
  'offsetStatus',//tinyint(1) unsigned DEFAULT '4' COMMENT '核销状态 5全部核销/4部分核销',
  'deleteStatus',//tinyint(1) DEFAULT '5' COMMENT '删除状态',
  'auditStatus',//tinyint(1) DEFAULT '1' COMMENT '审核状态（2审核成功  1待审核）',
  'receiptTypeId',//tinyint(2) DEFAULT NULL COMMENT '单据类型',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}