<?php
/**
 * Created by PhpStorm.
 * User: wxj
 * Date: 2019/10/30
 * Time: 14:17
 */

namespace JinDouYun\Dao\Finance;

use JinDouYun\Dao\BaseDao;

class DReceived extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'qianniao_received_1';
        $this->_primary = 'id';
        $this->_fields = [
            'id',//int(11) NOT NULL AUTO_INCREMENT COMMENT '收款单索引表id',
            'no',//varchar(255) DEFAULT NULL COMMENT '收款单据编号',
            'auditStatus',//tinyint(1) NOT NULL COMMENT '审核状态',
            'customerId',//int(11) DEFAULT NULL COMMENT '客户id',
            'customerName',//varchar(50) DEFAULT NULL COMMENT '客户名称',
            'sourceNo',//varchar(50) DEFAULT NULL COMMENT '源单据号',
            'sourceId',// int(10) NOT NULL DEFAULT '0' COMMENT '原单据id （只有银行打款有）'
            'originId',// int(10) NOT NULL DEFAULT '0' COMMENT '订单ID',
            'originNo',// varchar(25) DEFAULT NULL COMMENT '订单编号',
            'sourceNoMoney',
            'currentAccountName',//varchar(50) NOT NULL COMMENT '往来账户人',
            'financeType',//varchar(50) NOT NULL COMMENT '财务类型名称',
            'financeTypeId',//int(10) NOT NULL COMMENT '财务类型id',
            'shopId',//int(11) DEFAULT NULL COMMENT '所属商铺',
            'shopName',// varchar(255) DEFAULT NULL COMMENT '商铺名称',
            'totalMoney',//float(10,2) DEFAULT NULL COMMENT '总金额',
            'totalDiscountMoney',//float(10,2) DEFAULT NULL COMMENT '总优惠金额',
            'totalFinalMoney',//float(10,2) DEFAULT NULL COMMENT '总实际收款金额',
            'operatorId',//int(11) NOT NULL COMMENT '操作人员id',
            'receivedType', //int(10) unsigned DEFAULT '4' COMMENT '收款类型 5预售 /4应收',
            'offsetMoney',// decimal(15,2) DEFAULT NULL COMMENT '核销金额',
            'notOffsetMoney',// decimal(15,2) DEFAULT NULL COMMENT '未核销金额',
            'offsetStatus',// tinyint(1) DEFAULT NULL COMMENT '核销状态  5已核销',
            'receiptTime',//int(11) DEFAULT NULL COMMENT '单据日期',
            'createTime',//int(11) NOT NULL COMMENT '创建时间',
            'updateTime',//int(11) NOT NULL COMMENT '修改时间',
            'deleteStatus',
             'extends',// json DEFAULT NULL COMMENT '扩展字段'
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}