<?php
/**
 * Created by PhpStorm.
 * User: wxj
 * Date: 2019/10/30
 * Time: 14:17
 */

namespace JinDouYun\Dao\Finance;

use JinDouYun\Dao\BaseDao;

class DSupplierBalanceDetail extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'qianniao_supplier_balance_detail_1';
        $this->_primary = 'id';
        $this->_fields = [
            'id',//int(11) NOT NULL AUTO_INCREMENT COMMENT '供应商余额明细表',
            'supplierId',//int(11) DEFAULT NULL COMMENT '供应商id',
            'receiptTime',//int(11) DEFAULT NULL COMMENT '单据日期',
            'no',//char(25) DEFAULT NULL COMMENT '单据编号',
            'openingBalance',//decimal(15,4) DEFAULT NULL COMMENT '期初余额',
            'financeType',//varchar(255) DEFAULT NULL COMMENT '财务类型名称',
            'financeTypeId',//int(11) DEFAULT NULL COMMENT '财务类型id',
            'sourceId',// int(11) DEFAULT NULL COMMENT '源订单id',
            'sourceNo',//varchar(255) DEFAULT NULL COMMENT '源订单销货号',
            'salesAmount',//decimal(15,4) DEFAULT NULL COMMENT '销售金额',
            'discountMoney',//decimal(15,4) DEFAULT NULL COMMENT '优惠金额',
            'supplierAmount',//decimal(15,4) DEFAULT NULL COMMENT '供应商承担金额',
            'shouldPayAmount',//decimal(15,4) DEFAULT NULL COMMENT '应付金额',
            'actualPaidAmount',//decimal(15,4) DEFAULT NULL COMMENT '实际付款金额',
            'refundMoney',// decimal(15,4) DEFAULT '0.0000' COMMENT '退款金额',
            'shouldPayBalance',//decimal(15,4) DEFAULT NULL COMMENT '应付款余额',
            'remark',//text COMMENT '备注',
            'createTime',//int(11) DEFAULT NULL COMMENT '创建日期',
            'updateTime',//int(11) DEFAULT NULL COMMENT '修改日期',
            'extends',//json DEFAULT NULL COMMENT '扩展字段',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}