<?php
/**
 * 商品基础数据Dao
 * Created by PhpStorm.
 * User: XiaoMing
 * Date: 2019/10/30
 * Time: 14:27
 */

namespace JinDouYun\Dao\GoodsManage;

use JinDouYun\Dao\BaseDao;

class DGoodsBasic extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'goods_basic';
        $this->_primary = 'id';
        $this->_fields = [
            "id", //int(10) NOT NULL AUTO_INCREMENT,
            "images", //json DEFAULT NULL COMMENT '商品相册',
            "merchantId", // int(10) DEFAULT NULL COMMENT '商户id',
            "title", //varchar(255) NOT NULL DEFAULT '' COMMENT '商品名称',
            "condition",//搜索条件
            "code", //varchar(255) NOT NULL DEFAULT '' COMMENT '商品编码',
            "barCode", //varchar(255) NOT NULL DEFAULT '' COMMENT '商品条码',
            "categoryId", //int(10) NOT NULL default '0' COMMENT '商品分类id',
            "categoryPath", //varchar(50) NOT NULL default '' COMMENT '商品分类路径',
            "expireTime", //int(10) NOT NULL default '0' COMMENT '过期时间',
            "brandId", //int(10) NOT NULL default '0' COMMENT '品牌id',
            'describe', // 商品描述
            "tag", //varchar(255) NOT NULL DEFAULT '' COMMENT '关键词',
            "link", //varchar(255) NOT NULL DEFAULT '' COMMENT 'link',
            "description", //text NOT NULL COMMENT '商品详情',
            "noSalesShop", //json DEFAULT NULL COMMENT '禁止销售店铺',
            "extends", //json DEFAULT NULL COMMENT '拓展字段',
            "enableStatus", //tinyint(3) NOT NULL DEFAULT '5' COMMENT '商品状态  默认5 上线 6下线',
            "deleteStatus", //tinyint(3) NOT NULL DEFAULT '5' COMMENT '是否删除 4 删除 5正常',
            "createTime", //int(10) NOT NULL DEFAULT '0' COMMENT '创建时间',
            "updateTime", //int(10) NOT NULL DEFAULT '0' COMMENT '更新时间',
            "addUserId",//添加用户
            "salesManId",//添加业务员id
            "specGroup",//规格组
            "specType",//规格类型
            "storeId",//发布此商品的商户id
            "level",// tinyint(3) NOT NULL DEFAULT '5' COMMENT '商品级别 4商户 5平台',
            "supplierId",//供应商id
            "isEq"
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}