<?php
/**
 * 商品品牌Dao
 * Created by PhpStorm.
 * User: XiaoMing
 * Date: 2019/11/5
 * Time: 11:12
 */

namespace JinDouYun\Dao\GoodsManage;

use JinDouYun\Dao\BaseDao;

class DGoodsBrand extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'goods_brand';
        $this->_primary = 'id';
        $this->_fields = [
            "id", //int(10) NOT NULL AUTO_INCREMENT,
            "code", //varchar(255) NOT NULL DEFAULT '' COMMENT '品牌编码',
            "images", //varchar(255) NOT NULL DEFAULT '' COMMENT '品牌图片',
            "title", //varchar(255) NOT NULL DEFAULT '' COMMENT '品牌名称',
            "supplier", //varchar(255) NOT NULL DEFAULT '' COMMENT '供应商',
            "sort", //int(10) NOT NULL default '0' COMMENT '排序规则 数字越大越靠前',
            "enableStatus", //tinyint(3) NOT NULL DEFAULT '5' COMMENT '显示状态  默认5 显示 6隐藏',
            "deleteStatus", //tinyint(3) NOT NULL DEFAULT '5' COMMENT '是否删除  默认5 正常 4删除',
            "extends", //json DEFAULT NULL COMMENT '拓展字段',
            "createTime", //int(10) NOT NULL DEFAULT '0' COMMENT '创建时间',
            "updateTime", //int(10) NOT NULL DEFAULT '0' COMMENT '更新时间',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}