<?php


namespace JinDouYun\Dao\GoodsManage;

use JinDouYun\Dao\BaseDao;

/**
 * 规格名关系表
 * Class DSpec
 * @package JinDouYun\Dao\GoodsManage
 */
class DSpec extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'spec';
        $this->_primary = 'id';
        $this->_fields = [
            "id",//int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '规格组id',
            "pid",//int(11) NOT NULL default 0 COMMENT '属性名：0 属性值：属性名ID',
            "specName",//varchar(255) NOT NULL DEFAULT '' COMMENT '规格组名称(属性名名称 或属性值名称)',
            "extends",//json DEFAULT NULL COMMENT '拓展字段',
            "createTime",//int(10) NOT NULL DEFAULT '0' COMMENT '创建时间',
            "updateTime",//int(10) NOT NULL DEFAULT '0' COMMENT '更新时间',
            "deleteStatus",//tinyint(3) NOT NULL DEFAULT '5' COMMENT '是否删除 默认5 正常 4删除',
            "hidden",// varchar(255) NOT NULL DEFAULT 5 COMMENT '5 不隐藏 4隐藏',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}