<?php

namespace JinDouYun\Dao\Market;

use JinDouYun\Dao\BaseDao;

/**
 * Description: 用户活动商品购买记录表
 * Class DActivityGoodsUserLog
 * @package JinDouYun\Dao\Market
 */
class DActivityGoodsUserLog extends BaseDao
{
    /**
     * DActivityGoodsUserLog constructor.
     * @param string $serviceDB
     */
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'activity_goods_user_log';
        $this->_primary = 'id';
        $this->_fields = [
            "id",//int(11) NOT NULL AUTO_INCREMENT COMMENT '会员卡Id',
            "activityId",//int(11) DEFAULT NULL COMMENT '活动id',
            "goodsId",//int(2) DEFAULT '0' COMMENT '商品id',
            "skuId",//int(11) DEFAULT NULL COMMENT 'skuId',
            "shopId",//int(11) DEFAULT NULL COMMENT '商铺id',
            "createTime",//int(11) DEFAULT NULL COMMENT '创建日期',
            "updateTime",//int(11) DEFAULT NULL COMMENT '修改日期',
            "num",//int(11) DEFAULT '0' COMMENT '购买数量',
            "customerId",//int(11) DEFAULT '0' COMMENT '客户id',
            "userCenterId",//int(11) DEFAULT '0' COMMENT '用户id',
            "extend",//json DEFAULT NULL COMMENT '扩展字段',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}