<?php


namespace JinDouYun\Dao\Market;


use JinDouYun\Dao\BaseDao;

/**
 * @copyright   Copyright (c) https://www.qianniaovip.com All rights reserved
 * Description: 组合套餐
 * Class DComBinPackage
 * @package JinDouYun\Dao\Market
 */
class DComBinPackage extends BaseDao
{
    /**
     * DComBinPackage constructor.
     * @param string $serviceDB
     */
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'combin_package';
        $this->_primary = 'id';
        $this->_fields = [
            "id",//int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
            "title",//varchar(30) DEFAULT '' COMMENT '活动名称',
            "isExpire",//tinyint(3) DEFAULT '4' COMMENT '是否具有时间限制 默认5 4不限时间 5限制时间',
            "startTime",//int(10) NOT NULL DEFAULT '0' COMMENT '活动开始时间',
            "endTime",//int(10) NOT NULL DEFAULT '0' COMMENT '活动结束时间',
            "shopId",//int(10) NOT NULL DEFAULT '0' COMMENT '商铺id',
            "shopName",//varchar(30) DEFAULT NULL COMMENT '商铺名称',
            "goodsData",//json DEFAULT NULL COMMENT '活动商品数据',
            "price",//decimal(10,2) DEFAULT '0.00' COMMENT '套餐价格',
            "originPrice",//decimal(10,2) DEFAULT '0.00' COMMENT '套餐价格',
            "inventory",//decimal(10,2) DEFAULT NULL COMMENT '套餐设置库存',
            "saleNum",//decimal(10,2) DEFAULT NULL COMMENT '套餐已售数量',
            "isLimit",//tinyint(3) DEFAULT '4' COMMENT '是否开启每人限购 默认4 4不开启 5开启',
            "limitNum",//decimal(10,2) DEFAULT '0.00' COMMENT '每人限制购买数量',
            "expressType",//tinyint(3) DEFAULT '4' COMMENT '运费设置 默认4 4默认跟随商品 5包邮',
            "enableStatus",//tinyint(3) DEFAULT '4' COMMENT '是否启用 默认4 4禁用 5启用',
            "subOrderNum",//int(10) NOT NULL DEFAULT '0' COMMENT '订单数量',
            "subOrderPayMoney",//decimal(10,2) DEFAULT '0.00' COMMENT '订单实付金额',
            "createTime",//int(10) NOT NULL DEFAULT '0' COMMENT '创建时间',
            "updateTime",//int(10) NOT NULL DEFAULT '0' COMMENT '更新时间',
            "deleteStatus",
            "extends",//json DEFAULT NULL COMMENT '拓展字段',
            "materielNum",
            "goodsIds"
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];
        parent::__construct($serviceDB);
    }
}