<?php
/**
 * Created by PhpStorm.
 * User: wxj
 * Date: 2019/10/30
 * Time: 14:17
 */
namespace JinDouYun\Dao\Market;

use JinDouYun\Dao\BaseDao;

class DVipCard extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'vip_card';
        $this->_primary = 'id';
        $this->_fields = [
              'id',//int(11) NOT NULL AUTO_INCREMENT COMMENT '会员卡Id',
              'shopId',//int(11) DEFAULT NULL COMMENT '商铺id',
              'name',//varchar(50) DEFAULT NULL COMMENT '会员卡名称',
              'styleId',//int(2) DEFAULT '1' COMMENT '卡片样式id',
              'sort',//int(11) DEFAULT NULL COMMENT '排序',
              'mode',//tinyint(1) DEFAULT NULL COMMENT '会员卡模式  5所有商品  4指定商品',
              'goodsIds',//varchar(255) DEFAULT NULL COMMENT '指定的商品Id',
              'doubleDiscount',//tinyint(1) DEFAULT '4' COMMENT '折上折 5启用   4禁用',
              'freeShipping',//tinyint(1) DEFAULT NULL COMMENT '是否包邮  5包邮  4不包邮',
              'vipDiscount',//tinyint(1) DEFAULT NULL COMMENT '会员折扣 5有折扣  4没有折扣',
              'discount',//decimal(15,4) DEFAULT '0.0000' COMMENT '会员折扣',
              'hasNewCardCoupon',//tinyint(1) DEFAULT NULL COMMENT '开卡赠送优惠券 5赠送   4不赠送优惠券',
              'newCardCouponIds',//varchar(255) DEFAULT NULL COMMENT '开卡赠送的优惠券',
              'hasMonthCoupon',//tinyint(1) DEFAULT NULL COMMENT '每月领取优惠券 5领取   4不领取优惠券',
              'monthCouponIds',//varchar(255) DEFAULT NULL COMMENT '每月领取的优惠券Id',
              'deleteStatus',//tinyint(1) DEFAULT '5' COMMENT '删除状态 5正常  4删除',
              'enableStatus',//tinyint(1) DEFAULT NULL COMMENT '启用状态 5启用  4禁用',
              'createTime',//int(11) DEFAULT NULL COMMENT '创建日期',
              'updateTime',//int(11) DEFAULT NULL COMMENT '修改日期',
              'effectiveDate',//int(11) DEFAULT NULL COMMENT '有效期-1永久有效',
              'price',//decimal(15,4) DEFAULT '0.0000' COMMENT '价格',
              'totalNum',//int(11) DEFAULT '0' COMMENT '库存',
              'num',//int(11) DEFAULT '0' COMMENT '已售出的量',
              'remark',//text COMMENT '使用须知',
              'extend',//json DEFAULT NULL COMMENT '扩展字段',
              'memberSpecialPrice', // tinyint(3) DEFAULT '4' COMMENT '会员卡特价（5启用 ：4禁用）',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}