<?php
/**
 * Created by PhpStorm.
 * User: wxj
 * Date: 2019/10/30
 * Time: 14:17
 */
namespace JinDouYun\Dao\Market;

use JinDouYun\Dao\BaseDao;

class DVipCardOrder extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'vip_card_order';
        $this->_primary = 'id';
        $this->_fields = [
              'id',//int(10) NOT NULL AUTO_INCREMENT,
              'no',//char(20) NOT NULL COMMENT '订单编号',
              'shopId',//int(10) NOT NULL DEFAULT '0' COMMENT '店铺id',
              'outerTradeNo',//varchar(255) NOT NULL DEFAULT '' COMMENT '外部流水号(支付宝/微信返回的流水号)',
              'totalMoney',//decimal(12,2) DEFAULT '0.00' COMMENT '总金额',
              'payAmount',//decimal(12,2) DEFAULT '0.00' COMMENT '实付金额',
              'vipCardId',//int(11) DEFAULT NULL COMMENT '会员卡id',
              'customerName',//varchar(50) NOT NULL COMMENT '客户姓名',
              'customerId',//int(10) NOT NULL COMMENT '客户id',
              'payStatus',//tinyint(3) NOT NULL DEFAULT '4' COMMENT '支付状态  默认 4未支付 5已支付',
              'payType',//tinyint(3) DEFAULT NULL COMMENT '支付方式 1微信 2支付宝 3货到付款 4上门自提',
              'source',//tinyint(3) DEFAULT NULL COMMENT '订单来源 默认1 ios 2android 3小程序 4后台创建',
              'remark',//varchar(255) NOT NULL DEFAULT '' COMMENT '订单备注',
              'expireTime',//int(11) DEFAULT NULL COMMENT '过期时间',
              'extends',//json DEFAULT NULL COMMENT '拓展字段',
              'deleteStatus',//tinyint(3) NOT NULL DEFAULT '5' COMMENT '是否删除  默认5 正常 4删除',
              'enableStatus',// tinyint(1) DEFAULT '5' COMMENT '是否生效 5生效 4失效',
              'payTime',//int(10) NOT NULL DEFAULT '0' COMMENT '付款时间',
              'createTime',//int(10) NOT NULL DEFAULT '0' COMMENT '创建时间',
              'updateTime',//int(10) NOT NULL DEFAULT '0' COMMENT '更新时间',
              'salesManId',//int(10) DEFAULT '0' COMMENT '业务员id',
              'salesManName',//varchar(255) DEFAULT NULL COMMENT '业务员名称',
              'customerType',//tinyint(3) DEFAULT NULL COMMENT '客户类型',
              'userCenterId',//int(10) DEFAULT '0' COMMENT 'userCenterId',
              'successFullyTime',//int(10) DEFAULT '0' COMMENT '订单完成时间'
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}