<?php
/**
 * 商户申请Dao
 * Created by PhpStorm.
 * User: haoren
 * Date: 2020/09/25
 * Time: 09:40
 */

namespace JinDouYun\Dao\Merchant;

use JinDouYun\Dao\BaseDao;

class DMerchantApply extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'merchant_apply';
        $this->_primary = 'id';
        $this->_fields = [
            "id", //int(10) NOT NULL AUTO_INCREMENT COMMENT '商户入驻申请表',
            "enterpriseId", //int(10) NOT NULL COMMENT '企业id',
            "userCenterId", // int(10) DEFAULT NULL COMMENT '用户id',
            "groupId", //int(10) NOT NULL COMMENT '分组id',
            "name", //varchar(255) DEFAULT NULL COMMENT '商户名称',
            "desc", //varchar(255) DEFAULT NULL COMMENT '商户简介',
            'license',
            "category", //varchar(255) DEFAULT NULL COMMENT '类目',
            "provinceCode", //varchar(50) DEFAULT NULL COMMENT '省编码',
            "cityCode", //varchar(50) DEFAULT NULL COMMENT '市编码',
            "districtCode", //varchar(50) DEFAULT NULL COMMENT '区编码',
            "address", //varchar(255) DEFAULT NULL COMMENT '详细地址',
            "latitude", // varchar(255) DEFAULT NULL COMMENT '经度',
            "longitude", // varchar(255) DEFAULT NULL COMMENT '纬度',
            "contactName", //varchar(255) DEFAULT NULL COMMENT '联系人姓名',
            "contactMobile", //varchar(20) DEFAULT NULL COMMENT '联系人手机号',
            "info", //json DEFAULT NULL COMMENT '其他信息',
            "settleType", //tinyint(1) DEFAULT NULL COMMENT '结算设置',
            "settle", //json DEFAULT NULL COMMENT '结算设置内容',
            "auditType", //varchar(255) DEFAULT NULL COMMENT '审核设置',
            "audit", //json DEFAULT NULL COMMENT '审核设置内容',
            "settingType", //tinyint(1) DEFAULT NULL COMMENT '商户设置',
            "setting", //json DEFAULT NULL COMMENT '商户设置内容',
            "enabledStatus", //tinyint(1) DEFAULT NULL COMMENT '启用状态 4:禁用 5:启用',
            "auditStatus", //tinyint(1) DEFAULT NULL COMMENT '审核状态',
            'auditFailReason',
            "deleteStatus", //tinyint(1) DEFAULT NULL COMMENT '删除状态 4:删除 5:正常',
            "expireTime", // int(10) DEFAULT NULL COMMENT '到期时间',
            "auditTime", //int(10) DEFAULT NULL COMMENT '审核时间',
            "deleteTime", //int(10) DEFAULT NULL COMMENT '删除时间',
            "createTime", //int(10) DEFAULT NULL COMMENT '创建时间',
            "updateTime", //int(10) DEFAULT NULL COMMENT '修改时间',
            "extend",
            "balance",//decimal(8,2) DEFAULT '0.00' COMMENT '余额',
            "waitAuditWithdraw",// decimal(8,2) DEFAULT '0.00' COMMENT '提现待审核金额',
            "auditWithdraw",// decimal(8,2) DEFAULT '0.00' COMMENT '提现待入账金额',
            "withdraw" .// decimal(8,2) DEFAULT '0.00' COMMENT '已提现金额',
            "totalMoney",// decimal(8,2) DEFAULT '0.00' COMMENT '总金额',
            "orderNum",//int(10) DEFAULT NULL COMMENT '可提现订单总数',
            "auditOrderNum",//int(10) DEFAULT NULL COMMENT '等待审核订单数',
            "finishOrderNum",//int(10) DEFAULT NULL COMMENT '已结算订单数量',
            "notOrderNum",//int(10) DEFAULT NULL COMMENT '审核未通过订单数',
            "passOrderNum",//int(10) DEFAULT NULL COMMENT '审核通过订单数',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}