<?php
/**
 * Created by PhpStorm.
 * User: Gss
 * Date: 2021/5/19 0019
 * Time: 10:47
 */

namespace JinDouYun\Dao\Order;


use JinDouYun\Dao\BaseDao;

class DOrderPicking extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'order_picking';
        $this->_primary = 'id';
        $this->_fields = [
                'id',//int(11) NOT NULL COMMENT '自增id',
                'orderId',//int(11) NOT NULL COMMENT '订单id',
                'sort',//int(10) NOT NULL DEFAULT '0' COMMENT '排序值',
                'outNum',//double(10,4) NOT NULL DEFAULT '0.0000' COMMENT '已发货数量',
                'notOutNum',//double(10,4) NOT NULL DEFAULT '0.0000' COMMENT '未发货数量',
                'orderNum',//int(10) NOT NULL COMMENT '订单数量',
                'notPickingNum',//double(10,4) NOT NULL DEFAULT '0.0000' COMMENT '未拣货数量',
                'pickingNum',//double(10,4) NOT NULL DEFAULT '0.0000' COMMENT '已拣货数量',
                'outTime',//int(11) NOT NULL DEFAULT '0' COMMENT '预计发货时间',
                'otherNum',// int(11) DEFAULT NULL COMMENT '其他单位',
                'mangeId',//int(11) NOT NULL COMMENT '经手人',
                'mangeName',//varchar(255) DEFAULT NULL COMMENT '经手人',
                'createTime',//int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
                'updateTime',//int(11) DEFAULT NULL COMMENT '更新时间',
                'extends',//json DEFAULT NULL COMMENT '扩展字段',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}