<?php
/**
 * 订单收货信息Dao
 * Created by PhpStorm.
 * User: XiaoMing
 * Date: 2019/10/31
 * Time: 16:01
 */

namespace JinDouYun\Dao\Order;

use JinDouYun\Dao\BaseDao;

class DOrderReceive extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'order_receive';
        $this->_primary = 'id';
        $this->_fields = [
            "id", //int(10) NOT NULL AUTO_INCREMENT,
            "no", //bigint(20) NOT NULL COMMENT '订单编号',
            "orderId", //int(10) NOT NULL DEFAULT '0' COMMENT '订单Id',
            "customerId", //int(10) NOT NULL DEFAULT '0' COMMENT '客户Id',
            "customerCode", //varchar(255) NOT NULL DEFAULT '' COMMENT '客户编码',
            "realName", //varchar(255) NOT NULL DEFAULT '' COMMENT '收货人姓名',
            "mobile", //char(11) NOT NULL DEFAULT '' COMMENT '收货人电话',
            "address", //varchar(255) NOT NULL DEFAULT '' COMMENT '收货详细地址',
            "provinceCode", //int(10) NOT NULL DEFAULT '0' COMMENT '省份编码',
            "cityCode", //int(10) NOT NULL DEFAULT '0' COMMENT '城市编码',
            "districtCode", //int(10) NOT NULL DEFAULT '0' COMMENT '区编码',
            "remark", //varchar(255) NOT NULL DEFAULT '' COMMENT '收货备注',
            "extends", //json DEFAULT NULL COMMENT '拓展字段',
            "deleteStatus", //tinyint(3) NOT NULL DEFAULT '5' COMMENT '是否删除  默认5 正常 4删除',
            "createTime", //int(10) NOT NULL DEFAULT '0' COMMENT '创建时间',
            "updateTime", //int(10) NOT NULL DEFAULT '0' COMMENT '更新时间',
            "detailAddress",//varchar(255) NOT NULL DEFAULT '' COMMENT '详细地址',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}