<?php
/**
 * 订单退货详情Dao
 * Created by PhpStorm.
 * User: 小威
 * Date: 2019/12/03
 * Time: 15:40
 */

namespace JinDouYun\Dao\Order;

use JinDouYun\Dao\BaseDao;

class DOrderReturnDetails extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'order_return_details';
        $this->_primary = 'id';
        $this->_fields = [
            "id", //int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
            "linkId", //int(10) DEFAULT NULL COMMENT '连接id',
            "linkNo", //char(22) DEFAULT NULL COMMENT '连接单号',
            "goodsId", //int(10) DEFAULT NULL COMMENT '商品id',
            "goodsName", //varchar(30) DEFAULT NULL COMMENT '商品名称',
            "goodsCode", //varchar(20) DEFAULT NULL COMMENT '商品编号',
            "goodsBasicId", //int(10) DEFAULT NULL COMMENT '商品基础资料id',
            "skuId", //int(10) DEFAULT NULL COMMENT '单位id',
            "unitName",
            "skuName",
            "num", //decimal(20,8) DEFAULT NULL COMMENT '数量',
            "otherNum",// decimal(15,4) DEFAULT '0.0000' COMMENT '其他单位数量',
            "returnUnitPrice", //decimal(15,4) DEFAULT NULL COMMENT '退货单价',
            "saleUnitPrice", //decimal(15,4) DEFAULT NULL COMMENT '销售单价',
            "returnTotalPrice", //decimal(15,4) DEFAULT NULL COMMENT '退货总价',
            "saleTotalPrice", //decimal(15,4) DEFAULT NULL COMMENT '销售总价',
            "deleteStatus", //tinyint(3) DEFAULT '5' COMMENT '删除状态 4:删除  5:正常',
            "createTime", //int(10) DEFAULT NULL COMMENT '创建时间',
            "updateTime", //int(10) DEFAULT NULL COMMENT '修改时间',
            "extend", //json DEFAULT NULL COMMENT '扩展字段',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}