<?php


namespace JinDouYun\Dao\Order;


use JinDouYun\Dao\BaseDao;

/**
 * @copyright   Copyright (c) https://www.qianniaovip.com All rights reserved
 * Description: 供应商订单详情记录表
 * Class DSupplierOrderDetails
 * @package JinDouYun\Dao\Order
 */
class DSupplierOrderDetails extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'supplier_order_details';
        $this->_primary = 'id';
        $this->_fields = [
            "id",//int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
            "no",//char(25) NOT NULL COMMENT '订单编号',
            "supplierId",//int(10) DEFAULT NULL COMMENT '供应商Id',
            "supplierName",//varchar(30) DEFAULT NULL COMMENT '供应商名称',
            "userCenterId",//int(10) DEFAULT NULL COMMENT '供应商Id',
            "customerId",//int(10) DEFAULT NULL COMMENT '客户id',
            "customerName",//varchar(30) DEFAULT NULL COMMENT '客户名称',
            "shopId",//int(10) NOT NULL DEFAULT '0' COMMENT '商铺id',
            "shopName",//varchar(30) DEFAULT NULL COMMENT '商铺名称',
            "materielId",//int(11) NOT NULL COMMENT '物料id',
            "materielCode",//varchar(255) NOT NULL DEFAULT '' COMMENT '物料code',
            "goodsId",//int(11) NOT NULL COMMENT '商品id',
            "goodsName",//varchar(50) NOT NULL DEFAULT '' COMMENT '商品名称',
            "goodsImages",//varchar(255) DEFAULT '' COMMENT '商品图',
            "skuId",//int(10) DEFAULT NULL COMMENT 'skuId',
            "unitName",//varchar(50) DEFAULT NULL COMMENT '单位名称',
            "conversion",//decimal(10,2) DEFAULT NULL COMMENT '换算比率',
            "specGroup",//json DEFAULT NULL COMMENT '规格明细',
            "categoryPath",//varchar(50) DEFAULT '' COMMENT '分类路径',
            "brandId",//int(5) DEFAULT '0' COMMENT '品牌id',
            "categoryName",//varchar(255) DEFAULT '' COMMENT '分类名称',
            "brandName",//varchar(255) DEFAULT '' COMMENT '品牌名称',
            "barCode",//char(50) DEFAULT '' COMMENT '商品条码',
            "storageCode",//varchar(50) DEFAULT '' COMMENT '商品货架编码',
            "buyNum",//double(10,4) NOT NULL DEFAULT '0.0000' COMMENT '购买数量',
            "costPrice",//decimal(10,2) DEFAULT NULL COMMENT '商品成本价格',
            "price",//decimal(12,2) DEFAULT '0.00' COMMENT '商品销售单价',
            "totalMoney",//decimal(12,2) DEFAULT '0.00' COMMENT '商品小计金额',
            "createTime",//int(10) NOT NULL DEFAULT '0' COMMENT '创建时间',
            "updateTime",//int(10) NOT NULL DEFAULT '0' COMMENT '更新时间',
            "extends",//json DEFAULT NULL COMMENT '拓展字段',
            "reservoir",//库位信息
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}