<?php


namespace JinDouYun\Dao\Price;

use JinDouYun\Dao\BaseDao;

/**
 * 商品价格范围表
 * Class DPriceRangeSheet
 * @package JinDouYun\Dao\Price
 */
class DPriceRangeSheet extends BaseDao
{
    public function __construct($serviceDB = 'price')
    {
        $this->_table = 'priceRangeSheet';
        $this->_primary = 'id';
        $this->_fields = [
            "id",//int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
            "goodsCode",//varchar(50) COMMENT '商品code',
            "goodsName",//varchar(100) NOT NULL COMMENT '商品名称',
            "goodsId",//int(10) NOT NULL COMMENT '商品id',
            "shopId",//int(10) NOT NULL COMMENT '店铺id',
            "createTime",//int(10) NOT NULL COMMENT '创建时间',
            "updateTime",//int(10) NOT NULL COMMENT '修改时间',
            "deleteStatus",//tinyint(3) NOT NULL DEFAULT '1' COMMENT '删除状态 4删除 5正常',
            "salePrice",//json NOT NULL COMMENT '最低/高价',
            "shopName",//varchar(50) DEFAULT NULL COMMENT '店铺名称',
            "extends",//json COMMENT '最低/高价',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}