<?php


namespace JinDouYun\Dao\Price;


use JinDouYun\Dao\BaseDao;

/**
 * @copyright   Copyright (c) https://www.qianniaovip.com All rights reserved
 * Description: 供应商报价单
 * Class DSupplierOfferPriceSheet
 * @package JinDouYun\Dao\Price
 */
class DSupplierOfferPriceSheet extends BaseDao
{
    public function __construct($serviceDB = 'price')
    {
        $this->_table = 'supplierOfferPrice_sheet';
        $this->_primary = 'id';
        $this->_fields = [
            "id",//int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
            "no",//char(25) NOT NULL COMMENT '订单编号',
            "supplierId",//int(10) DEFAULT '0' COMMENT '供应商id',
            "supplierName",//varchar(50) DEFAULT '1,2' COMMENT '供应商名称',
            "materielNum",// int(10) NOT NULL DEFAULT '0' COMMENT '物料数量',
            "auditStatus",//tinyint(3) DEFAULT '2' COMMENT '审核状态 默认1 待审 2审核通过 3 审核未通过 4 审核中',
            "deleteStatus",//tinyint(3) NOT NULL DEFAULT '5' COMMENT '是否删除 4 删除 5正常',
            "createTime",//int(10) NOT NULL DEFAULT '0' COMMENT '创建时间',
            "updateTime",//int(10) NOT NULL DEFAULT '0' COMMENT '更新时间',
            "extends",//json DEFAULT NULL COMMENT '拓展字段',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}