<?php
/**
 * 采购退货商品明细Dao
 * Created by PhpStorm.
 * User: XiaoMing
 * Date: 2019/11/11
 * Time: 17:53
 */

namespace JinDouYun\Dao\Purchase;

use JinDouYun\Dao\BaseDao;

class DPurchaseOutGoods extends BaseDao
{
    public function __construct($serviceDB = 'stock')
    {
        $this->_table = 'purchase_out_goods';
        $this->_primary = 'id';
        $this->_fields = [
            "id", //int(10) NOT NULL AUTO_INCREMENT,
            "purchaseOutId", //int(10) NOT NULL DEFAULT '0' COMMENT '采购退货单id',
            "goodsId", //int(10) NOT NULL DEFAULT '0' COMMENT '商品id',
            "goodsCode", //varchar(50) NOT NULL DEFAULT '' COMMENT '商品编码',
            "goodsName", //varchar(50) NOT NULL DEFAULT '' COMMENT '商品名称',
            "unitName", //json DEFAULT NULL COMMENT '单位',
            "skuName", //json DEFAULT NULL COMMENT '单位',
            "skuId",//int(10) NOT NULL DEFAULT '0' COMMENT 'skuId',
            "buyerNum", //int(10) NOT NULL DEFAULT '0' COMMENT '采购数量',
            "otherNum",// decimal(20,8) DEFAULT '0.00000000' COMMENT '其他单位数量',
            "buyerUnitPrice", //decimal(12,4) default '0.0000' COMMENT '采购单价',
            "subtotalPrice", // decimal(12,4) default '0.0000' COMMENT '小计金额(数量*单价)',
            "couponAmount", //decimal(12,4) default '0.0000' COMMENT '优惠金额',
            "otherAmount", //decimal(12,4) default '0.0000' COMMENT '其他金额',
            "deleteStatus", //tinyint(3) NOT NULL DEFAULT '5' COMMENT '是否删除 默认5 正常 4删除',
            "extends", //json DEFAULT NULL COMMENT '拓展字段',
            "createTime", //int(10) NOT NULL DEFAULT '0' COMMENT '创建时间',
            "updateTime", //int(10) NOT NULL DEFAULT '0' COMMENT '更新时间',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}