<?php
/**
 * 供应商Dao
 * Created by PhpStorm.
 * User: XiaoMing
 * Date: 2019/10/31
 * Time: 15:49
 */

namespace JinDouYun\Dao\Purchase;

use JinDouYun\Dao\BaseDao;

class DSupplier extends BaseDao
{
    public function __construct($serviceDB = 'stock')
    {
        $this->_table = 'supplier';
        $this->_primary = 'id';
        $this->_fields = [
            "id", //int(10) NOT NULL AUTO_INCREMENT,
            'userCenterId',
            'token',
            "code", //varchar(255) NOT NULL DEFAULT '' COMMENT '供应商编码',
            "title", //varchar(255) NOT NULL DEFAULT '' COMMENT '供应商名称',
            "provinceCode", //int(10) NOT NULL DEFAULT '0' COMMENT '省份编码',
            "cityCode", //int(10) NOT NULL DEFAULT '0' COMMENT '城市编码',
            "districtCode", //int(10) NOT NULL DEFAULT '0' COMMENT '区编码',
            "address", //varchar(255) NOT NULL DEFAULT '' COMMENT '详细地址',
            "accountName", //varchar(50) NOT NULL DEFAULT '' COMMENT '户名',
            "bankName", //varchar(50) NOT NULL DEFAULT '' COMMENT '银行',
            "bankCard", //varchar(255) NOT NULL DEFAULT '' COMMENT '银行卡号',
            "realName", //varchar(50) NOT NULL DEFAULT '' COMMENT '联系人姓名',
            "sex", //tinyint(3) DEFAULT NULL COMMENT '性别 4女 5男',
            "position", //varchar(50) NOT NULL DEFAULT '' COMMENT '职务',
            "mobile", //char(11) NOT NULL DEFAULT '' COMMENT '手机号',
            "phone", //varchar(50) NOT NULL DEFAULT '' COMMENT '电话',
            "email", //varchar(50) NOT NULL DEFAULT '' COMMENT '邮箱',
            "remark", //varchar(255) NOT NULL DEFAULT '' COMMENT '备注',
            "extends", //json DEFAULT NULL COMMENT '拓展字段',
            "enableStatus", //tinyint(3) NOT NULL DEFAULT '5' COMMENT '状态  默认5 正常 4关闭',
            "deleteStatus", //tinyint(3) NOT NULL DEFAULT '5' COMMENT '是否删除 默认5 正常 4删除',
            "createTime", //int(10) NOT NULL DEFAULT '0' COMMENT '创建时间',
            "updateTime", //int(10) NOT NULL DEFAULT '0' COMMENT '更新时间',
            "money",//
            "waitAuditWithdraw",// decimal(8,2) DEFAULT '0.00' COMMENT '提现待审核金额',
            "auditWithdraw",// decimal(8,2) DEFAULT '0.00' COMMENT '提现待入账金额',
            "withdraw",// decimal(8,2) DEFAULT '0.00' COMMENT '已提现金额',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}