<?php


namespace JinDouYun\Dao\Purchase;


use JinDouYun\Dao\BaseDao;

/**
 * @copyright   Copyright (c) https://www.qianniaovip.com All rights reserved
 * Description:
 * Class DSupplierWithdraw
 * @package JinDouYun\Dao\Purchase
 */
class DSupplierWithdraw extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'supplier_withdraw';
        $this->_primary = 'id';
        $this->_fields = [
            "id",//int(11) NOT NULL AUTO_INCREMENT,
            "no",
            "supplierId",//int(10) DEFAULT NULL COMMENT '供应商Id',
            "supplierName",//varchar(30) DEFAULT NULL COMMENT '供应商名称',
            "type",//tinyint(3) NOT NULL DEFAULT '0' COMMENT '结算方式',
            "accountContent",//json NOT NULL COMMENT '到账账号信息',
            "money",//decimal(10,2) DEFAULT NULL COMMENT '申请金额',
            "auditId",//int(10) DEFAULT NULL COMMENT '审核人id',
            "auditName",//varchar(30) DEFAULT NULL COMMENT '审核人姓名',
            "auditTime",//int(10) DEFAULT NULL COMMENT '审核时间',
            "auditStatus",//tinyint(3) DEFAULT '1' COMMENT '审核状态 1:申请提现 2:打款成功 3:提现审核拒绝 4:审核成功等待打款',
            "rate",//decimal(10,2) DEFAULT NULL COMMENT '抽成比率 eg: 2% (2.00)',
            "fee",//decimal(10,2) DEFAULT NULL COMMENT '抽成金额',
            "reason",
            "nowMoney",//decimal(10,2) NOT NULL COMMENT '预计打款金额',
            "payTime",//int(10) NOT NULL DEFAULT '0' COMMENT '打款时间',
            "createTime",//int(10) NOT NULL DEFAULT '0' COMMENT '创建时间',
            "updateTime",//int(10) NOT NULL DEFAULT '0' COMMENT '更新时间',
            "extends",//json DEFAULT NULL COMMENT '拓展字段',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}