<?php
/**
 * 提成规则Dao
 * Created by PhpStorm.
 * User: haoren
 * Date: 2021/03/25
 * Time: 15:00
 */

namespace JinDouYun\Dao\Reward;

use JinDouYun\Dao\BaseDao;

class DRewardRule extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'reward_rule';
        $this->_primary = 'id';
        $this->_fields = [
            "id", //int(10) NOT NULL AUTO_INCREMENT COMMENT '主键id',
            "shopId", //int(10) DEFAULT '0' COMMENT '商铺id',
            "title", //varchar(255) DEFAULT NULL COMMENT '名称',
            "percentage", //decimal(10,2) DEFAULT NULL COMMENT '比例',
            "goods", //json DEFAULT NULL COMMENT '商品',
            "computed", //tinyint(1) DEFAULT '5' COMMENT '计算类型 4:不包含商品 5:包含商品',
            "enableStatus", //tinyint(1) DEFAULT '5' COMMENT '启用状态 4:删除 5:正常',
            "deleteStatus", //tinyint(1) DEFAULT '5' COMMENT '删除状态 4:删除 5:正常',
            "createTime", //int(10) DEFAULT NULL COMMENT '创建时间',
            "updateTime", //int(10) DEFAULT NULL COMMENT '修改时间',
            "extend", //json DEFAULT NULL COMMENT '扩展字段',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}