<?php
/**
 * 商铺管理模块
 * Created by PhpStorm.
 * User: wxj
 * Date: 2019/10/31
 * Time: 15:02
 */

namespace JinDouYun\Dao\Shop;

use JinDouYun\Dao\BaseDao;

class DShop extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'shop';
        $this->_primary = 'id';
        $this->_fields = [
            "id", //int(11) NOT NULL AUTO_INCREMENT COMMENT '商铺id',
            "enterpriseId", //int(11) NOT NULL COMMENT '企业实体id',
            "merchantId", //int(10) DEFAULT NULL COMMENT '商户id',
            "warehouseId", //int(11) DEFAULT NULL COMMENT '仓库id',
            "name", //varchar(255) DEFAULT NULL COMMENT '商铺名称',
            "token", //varchar(255) DEFAULT NULL COMMENT '商铺token',
            "costType", //tinyint(3) NOT NULL DEFAULT '1' COMMENT '1:移动加权平均法 2:个别计价法',
            "logo", //varchar(255) NOT NULL COMMENT '商铺logo',
            "shopCode", //varchar(255) DEFAULT NULL COMMENT '商铺仓库编码',
            "shopType", //int(10) DEFAULT NULL COMMENT '商铺类型',
            "openTime", //json DEFAULT NULL COMMENT '营业时间',
            "contactName", //varchar(50) NOT NULL COMMENT '联系人',
            "mobile", //char(11) NOT NULL COMMENT '联系电话',
            "deleteStatus", //tinyint(4) DEFAULT '5' COMMENT '删除状态(5未删除 4已删除)',
            "createTime", //int(10) DEFAULT NULL COMMENT '创建时间',
            "updateTime", //int(10) DEFAULT NULL COMMENT '修改时间',
            "enableStatus", //tinyint(4) DEFAULT '5' COMMENT '启用状态(4未启用 5已启用)',
            "isMaster", //tinyint(1) DEFAULT '4' COMMENT '总店 4:否 5:是',
            "provinceCode", //varchar(20) DEFAULT NULL COMMENT '省编码',
            "cityCode", //varchar(20) DEFAULT NULL COMMENT '市编码',
            "districtCode", //varchar(20) DEFAULT NULL COMMENT '区编码',
            "address", //varchar(100) DEFAULT NULL COMMENT '详细地址',
            "latitude", //varchar(255) DEFAULT NULL COMMENT '纬度',
            "longitude", //varchar(255) DEFAULT NULL COMMENT '经度',
            "salesArea", //json DEFAULT NULL COMMENT '销售区域',
            "managerId", //int(11) DEFAULT NULL COMMENT '店长userCenterId',
            "describe", //varchar(255) DEFAULT '' COMMENT '店铺描述',
            "extends",
            "modelType",
            "recommend_user_id"
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}