<?php
/**
 * 商铺合作管理Dao
 * Created by PhpStorm.
 * User: 小威
 * Date: 2019/11/01
 * Time: 10:00
 */

namespace JinDouYun\Dao\ShopPartner;

use JinDouYun\Dao\BaseDao;

class DShopPartner extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'shop_partner';
        $this->_primary = 'id';
        $this->_fields = [
            "id", //int(10) NOT NULL AUTO_INCREMENT COMMENT '主键id',
            "logo", //varchar(255) DEFAULT NULL COMMENT '企业logo',
            "name", //varchar(30) DEFAULT NULL COMMENT '合伙人姓名/合伙企业名称',
            "model", //tinyint(3) DEFAULT NULL COMMENT '经营模式 1:直营 2:加盟',
            "provinceCode", //varchar(20) DEFAULT NULL COMMENT '省编码',
            "cityCode", //varchar(20) DEFAULT NULL COMMENT '市编码',
            "districtCode", //varchar(20) DEFAULT NULL COMMENT '区编码',
            "address", //varchar(255) DEFAULT NULL COMMENT '合伙人地址',
            "userCenterId", //int(10) DEFAULT NULL COMMENT '职工负责人id',
            "userName",
            "mobile", //char(11) DEFAULT NULL COMMENT '负责人联系电话',
            "enterpriseId", //int(11) NOT NULL COMMENT '企业id',
            "shopId", //int(10) NOT NULL COMMENT '管理的商铺id',
            "deleteStatus", //tinyint(3) DEFAULT '5' COMMENT '删除状态 5:正常 4:删除',
            "enableStatus", //tinyint(3) DEFAULT '5' COMMENT '启用状态  5 启用 4禁用',
            "createTime", //int(10) DEFAULT NULL COMMENT '创建时间',
            "updateTime", //int(10) DEFAULT NULL COMMENT '更新时间',
            "extend", //json DEFAULT NULL COMMENT '扩展字段',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}