<?php
/**
 * 仓库调拨管理Dao
 * Created by PhpStorm.
 * User: 小威
 * Date: 2019/11/29
 * Time: 15:00
 */

namespace JinDouYun\Dao\Stock;

use JinDouYun\Dao\BaseDao;

class DAllocate extends BaseDao
{
    public function __construct($serviceDB = 'stock')
    {
        $this->_table = 'allocate';
        $this->_primary = 'id';
        $this->_fields = [
            "id", //int(10) NOT NULL AUTO_INCREMENT COMMENT '主键id',
            "no", //char(20) DEFAULT NULL COMMENT '调拨入库单号',
            "warehouseId", //int(10) DEFAULT NULL COMMENT '仓库id',
            "warehouseName", //int(10) DEFAULT NULL COMMENT '仓库name',
            "num", //decimal(20,8) NOT NULL COMMENT '调拨商品数量',
            "inWarehouseId", //int(10) DEFAULT NULL COMMENT '调拨进入仓库id',
            "inWarehouseName", //int(10) DEFAULT NULL COMMENT '调拨进入仓库name',
            "operatorId", //int(10) DEFAULT NULL COMMENT '制单人信息',
            "operatorName", //varchar(30) DEFAULT NULL COMMENT '制单人姓名',
            "auditId", //int(10) DEFAULT NULL COMMENT '审核人id',
            "auditName", //varchar(30) DEFAULT NULL COMMENT '审核人姓名',
            "auditTime", //int(10) DEFAULT NULL COMMENT '审核时间',
            "auditStatus", //tinyint(3) DEFAULT '1' COMMENT '审核状态 1:待审核 2:已审核 3:审核失败 4:审核中',
            "remark", //varchar(255) DEFAULT NULL COMMENT '备注',
            "deleteStatus", //tinyint(3) DEFAULT '5' COMMENT '删除状态 4:已删除 5:正常',
            "createTime", //int(10) DEFAULT NULL COMMENT '创建时间',
            "updateTime", //int(10) DEFAULT NULL COMMENT '修改时间',
            "extend", //json DEFAULT NULL COMMENT '扩展字段',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}