<?php
/**
 * 入库详情管理Dao
 * Created by PhpStorm.
 * User: 小威
 * Date: 2019/11/11
 * Time: 14:00
 */

namespace JinDouYun\Dao\Stock;

use JinDouYun\Dao\BaseDao;

class DInventoryInDetails extends BaseDao
{
    public function __construct($serviceDB = 'stock')
    {
        $this->_table = 'inventory_in_details';
        $this->_primary = 'id';
        $this->_fields = [
            'id',//int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
          'linkId',//int(10) DEFAULT NULL COMMENT '入库id',
          'linkNo',//char(25) DEFAULT NULL COMMENT '入库单号',
          'InWarehouse',//json DEFAULT NULL COMMENT '入库仓库',
          'materielId',//int(10) DEFAULT NULL COMMENT '物料id',
          'materielName',//varchar(255) DEFAULT NULL COMMENT '物料名称',
          'materielCode',//varchar(20) DEFAULT NULL COMMENT '物料编号',
          'skuId',//int(10) DEFAULT NULL COMMENT '单位id',
          'unitName',//varchar(255) NOT NULL COMMENT '单位名称',
          'skuName',//varchar(255) NOT NULL COMMENT '属性名称',
          'skuStorage',//varchar(255) DEFAULT NULL COMMENT '货架编码',
          'num',//decimal(20,8) DEFAULT NULL COMMENT '数量',
          'inNum',//decimal(20,8) DEFAULT NULL COMMENT '入库数量',
          'otherNum',//decimal(20,8) DEFAULT '0.00000000' COMMENT '其他单位数量',
          'unitPrice',//decimal(15,4) DEFAULT NULL COMMENT '单价',
          'totalPrice',//decimal(15,4) DEFAULT NULL COMMENT '总价',
          'inCost',//decimal(15,4) DEFAULT '0.0000' COMMENT '入库成本',
          'inCostTotal',//decimal(15,4) DEFAULT '0.0000' COMMENT '入库总成本',
          'areaId',//int(10) DEFAULT '0' COMMENT '库区id',
          'areaName',//varchar(255) DEFAULT NULL COMMENT '库区名称',
          'areaCode',//varchar(255) DEFAULT NULL COMMENT '库区编码',
          'storageLocationId',//int(10) DEFAULT '0' COMMENT '库位id',
          'storageLocationName',//varchar(255) DEFAULT NULL COMMENT '库位名称',
          'storageLocationCode',//varchar(255) DEFAULT NULL COMMENT '库位编码',
          'productionData',//int(10) DEFAULT '0' COMMENT '生产日期',
          'createTime',//int(10) DEFAULT NULL COMMENT '创建时间',
          'updateTime',//int(10) DEFAULT NULL COMMENT '修改时间',
          'extend',//json DEFAULT NULL COMMENT '扩展字段',
          'deleteStatus',//tinyint(255) unsigned NOT NULL DEFAULT '5' COMMENT '删除状态 4删除 5正常',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}