<?php
/**
 * 库存锁定记录Dao
 * Created by PhpStorm.
 * User: 小威
 * Date: 2019/11/13
 * Time: 11:30
 */

namespace JinDouYun\Dao\Stock;

use JinDouYun\Dao\BaseDao;

class DInventoryLocking extends BaseDao
{
    public function __construct($serviceDB = 'stock')
    {
        $this->_table = 'inventory_locking';
        $this->_primary = 'id';
        $this->_fields = [
            "id", //int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
            "shopId",
            "materielId", //int(10) NOT NULL COMMENT '物料id',
            "operatorId", //int(10) DEFAULT NULL COMMENT '操作人id',
            "operatorName", //varchar(30) DEFAULT NULL COMMENT '操作人姓名',
            "materielCode", //char(15) DEFAULT NULL COMMENT '物料编码',
            "originId", //int(10) NOT NULL COMMENT '源头id',
            "originNo", //char(25) NOT NULL COMMENT '源头单号',
            "source", //tinyint(3) DEFAULT NULL COMMENT '来源',
            "sourceNo", //char(25) NOT NULL COMMENT '来源单号',
            "lockingNum", //decimal(20,8) NOT NULL COMMENT '数量',
            "skuId", //int(10) DEFAULT NULL COMMENT '单位id',
            "lockStatus", //tinyint(3) DEFAULT '4' COMMENT '状态 4:已锁定 5:已解锁',
            "unlockTime", //int(10) DEFAULT NULL COMMENT '解锁时间',
            "createTime", //int(10) DEFAULT NULL COMMENT '创建时间',
            "updateTime", //int(10) DEFAULT NULL COMMENT '更新时间',
            "extend", //json DEFAULT NULL COMMENT '扩展字段',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time(),
            'updateTime' => time()

        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}