<?php
/**
 * Created by PhpStorm.
 * User: Gss
 * Date: 2021/5/17 0017
 * Time: 17:28
 */

namespace JinDouYun\Dao\Stock;


use JinDouYun\Dao\BaseDao;

class DPicking extends BaseDao
{
    public function __construct($serviceDB = 'stock')
    {
        $this->_table = 'order';
        $this->_primary = 'id';
        $this->_fields = [
            'id',//int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
            'no',//varchar(255) NOT NULL COMMENT '单据编号',
            'shopId',//int(10) NOT NULL DEFAULT '0' COMMENT '店铺id',
            'shopName',//varchar(255) DEFAULT NULL COMMENT '店铺名称',
            'merchantId',//int(10) NOT NULL DEFAULT '0' COMMENT '商户id',
            'originId',//int(10) NOT NULL DEFAULT '0' COMMENT '源订单id',
            'originNo',//varchar(255) NOT NULL COMMENT '源订单no',
            'warehouseId',//int(10) NOT NULL COMMENT '仓库id',
            'warehouseName',//varchar(255) NOT NULL COMMENT '仓库名称',
            'personnel',//int(10) NOT NULL COMMENT '拣货id',
            'personnelName',//varchar(255) NOT NULL COMMENT '拣货人',
            'currentUnitId',// int(11) NOT NULL COMMENT '往来单位Id',
            'currentUnit',//varchar(255) NOT NULL COMMENT '往来单位',
            'sort',//int(10) NOT NULL DEFAULT '0' COMMENT '排序',
            'number',//int(10) NOT NULL DEFAULT '0' COMMENT '数量',
            'goodsLine',//int(10) NOT NULL DEFAULT '0' COMMENT '商品行数',
            'totalMoney',//decimal(10,2) NOT NULL DEFAULT '0.00' COMMENT '销售金额',
            'notPickingNum',//double(10,4) NOT NULL DEFAULT '0.0000' COMMENT '未拣货数量',
            'pickingNum',//double(10,4) NOT NULL DEFAULT '0.0000' COMMENT '拣货数量',
            'outNum',//double(10,4) NOT NULL COMMENT '发货数量',
            'notOutNum',//double(10,4) NOT NULL COMMENT '未发货数量',
            'outTime',//int(10) DEFAULT NULL COMMENT '发货时间',
            'deliveryType',//tinyint(1) NOT NULL DEFAULT '1' COMMENT '配送方式',
            'address',//varchar(255) DEFAULT NULL COMMENT '地址',
            'managerId',//int(10) NOT NULL DEFAULT '0' COMMENT '订单经手人ID',
            'managerName',//varchar(255) NOT NULL COMMENT '订单经手人',
            'pickingStatus',//tinyint(1) NOT NULL DEFAULT '4' COMMENT '拣货状态',
            'pickingType',//tinyint(1) NOT NULL DEFAULT '1' COMMENT '拣货类型',
            'remark',//varchar(255) DEFAULT NULL COMMENT '备注',
            'createTime',//int(11) NOT NULL COMMENT '创建时间',
            'updateTime',//int(11) DEFAULT NULL COMMENT '更新时间',
            'extend',//json DEFAULT NULL COMMENT '扩展字段',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}