<?php
/**
 * Created by PhpStorm.
 * User: Gss
 * Date: 2021/5/17 0017
 * Time: 17:34
 */

namespace JinDouYun\Dao\Stock;


use JinDouYun\Dao\BaseDao;

class DPickingGoods extends BaseDao
{
    public function __construct($serviceDB = 'stock')
    {
        $this->_table = 'picking_goods';
        $this->_primary = 'id';
        $this->_fields = [
                'id',//int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
                'no',//varchar(255) NOT NULL COMMENT '单据编号',
                'pickingId',//int(11) NOT NULL COMMENT '拣货单id',
                'goodsCode',//varchar(255) NOT NULL COMMENT '商品编号',
                'goodsId',//int(10) NOT NULL COMMENT '商品Id',
                'goodsName',//varchar(255) NOT NULL COMMENT '商品名称',
                'shopId',//int(10) NOT NULL COMMENT '商铺Id',
                'shopName',//varchar(255) NOT NULL COMMENT '商铺名称',
                'merchantId',//int(10) NOT NULL COMMENT '商户id',
                'originPrice',//decimal(12,2) NOT NULL DEFAULT '0.00' COMMENT '原始单价',
                'price',//decimal(12,2) NOT NULL DEFAULT '0.00' COMMENT '商品单价',
                'pickingNum',//double(10,4) NOT NULL DEFAULT '0.0000' COMMENT '应拣货数量',
                'otherNum',//double(10,4) NOT NULL DEFAULT '0.0000' COMMENT '其他数量',
                'totalMoney',//decimal(12,2) NOT NULL DEFAULT '0.00' COMMENT '小计金额',
                'orderNum',//int(10) NOT NULL COMMENT '订单数量',
                'deleteStatus',//tinyint(2) NOT NULL DEFAULT '5' COMMENT '删除状态',
                'goodsBasicId',//int(10) NOT NULL COMMENT 'goodsBasicId',
                'unitName',//varchar(255) DEFAULT NULL COMMENT '单位名称',
                'conversion',//decimal(12,2) NOT NULL DEFAULT '0.00' COMMENT '换算比率',
                'outCostPrice',//decimal(12,2) NOT NULL DEFAULT '0.00' COMMENT '成本',
                'pickingStatus',//tinyint(1) NOT NULL DEFAULT '1' COMMENT '拣货状态 ',
                'isGiveaway',//tinyint(1) NOT NULL DEFAULT '4' COMMENT '是否赠品 4:否 5:是',
                'barCode',//varchar(50) DEFAULT NULL COMMENT '商品条码',
                'isEq',//tinyint(1) NOT NULL DEFAULT '4' COMMENT '是否是超码商品',
                'categoryPath',//varchar(50) DEFAULT NULL COMMENT '分类路径',
                'pickingedNum',//double(10,4) NOT NULL DEFAULT '0.0000' COMMENT '本次拣货数量',
                'InspectionNum',//double(10,4) NOT NULL DEFAULT '0.0000' COMMENT '应验数量',
                'InspectionedNum',//double(10,4) NOT NULL DEFAULT '0.0000' COMMENT '验货数量',
                'InspectionStatus',//tinyint(1) NOT NULL DEFAULT '4' COMMENT '验货状态  5全部验货/4未验货/3部分验货',
                'specGroup',// json DEFAULT NULL COMMENT '规格明细',
                'goodsImages',// varchar(255) DEFAULT '' COMMENT '商品图',
                'remark',//varchar(255) DEFAULT NULL COMMENT '备注',
                'extends',//json DEFAULT NULL COMMENT '扩展字段',
                'createTime',//int(11) NOT NULL COMMENT '创建时间',
                'updateTime',//int(11) DEFAULT NULL COMMENT '更新时间',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}