<?php
/**
 * 报损库存Dao
 * Created by PhpStorm.
 * User: haoren
 * Date: 2021/03/09
 * Time: 11:40
 */

namespace JinDouYun\Dao\Stock;

use JinDouYun\Dao\BaseDao;

class DReportLoss extends BaseDao
{
    public function __construct($serviceDB = 'stock')
    {
        $this->_table = 'report_loss';
        $this->_primary = 'id';
        $this->_fields = [
            "id", //int(10) NOT NULL AUTO_INCREMENT COMMENT '库存报损记录表',
            "warehouseId", //int(10) DEFAULT NULL COMMENT '仓库id',
            "warehouseName", //varchar(255) DEFAULT NULL COMMENT '仓库名称',
            "no", //varchar(255) DEFAULT NULL COMMENT '单号',
            "skuNum", //int(10) DEFAULT NULL COMMENT '物料sku数量',
            "amount", //decimal(20,4) DEFAULT '0.0000' COMMENT '报损总金额',
            "operatorId", //int(10) DEFAULT NULL COMMENT '制单人id',
            "operatorName", //varchar(255) DEFAULT NULL COMMENT '制单人姓名',
            "auditId", //int(10) DEFAULT NULL COMMENT '审核人id',
            "auditName", //varchar(255) DEFAULT NULL COMMENT '审核人姓名',
            "remark", //varchar(255) DEFAULT NULL COMMENT '备注',
            "auditTime", //int(10) DEFAULT NULL COMMENT '审核时间',
            "auditStatus", //tinyint(1) DEFAULT '1' COMMENT '审核状态',
            "deleteStatus", //tinyint(1) DEFAULT '5' COMMENT '删除状态',
            "createTime", //int(10) DEFAULT NULL COMMENT '创建时间',
            "updateTime", //int(10) DEFAULT NULL COMMENT '修改时间',
            "extend", //json DEFAULT NULL COMMENT '扩展字段',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}