<?php
/**
 * 库区Dao
 * Created by PhpStorm.
 * User: haoren
 * Date: 2020/12/14
 * Time: 16:00
 */

namespace JinDouYun\Dao\Stock;

use JinDouYun\Dao\BaseDao;

class DReservoirArea extends BaseDao
{
    public function __construct($serviceDB = 'stock')
    {
        $this->_table = 'reservoir_area';
        $this->_primary = 'id';
        $this->_fields = [
                'id' ,//int(10) NOT NULL AUTO_INCREMENT COMMENT 'id',
                'enterpriseId' ,//int(10) NOT NULL COMMENT '企业id'
                'warehouseId',// int(10) NOT NULL COMMENT '仓库id',
                'name' ,//varchar(255) DEFAULT NULL COMMENT '库区名称',
                'code' ,//varchar(255) DEFAULT NULL COMMENT '库区编码',
                'length' ,//decimal(20,2) DEFAULT NULL COMMENT '长 cm',
                'width' ,//decimal(20,2) DEFAULT NULL COMMENT '宽 cm',
                'height' ,//decimal(20,2) DEFAULT NULL COMMENT '高 cm',
                'weight' ,//decimal(20,2) DEFAULT NULL COMMENT '重量 kg',
                'type' ,//tinyint(1) DEFAULT NULL COMMENT '库区类型',
                'enableStatus' ,//tinyint(1) DEFAULT '5' COMMENT '启用状态 4:禁用 5:启用',
                'deleteStatus' ,//tinyint(1) DEFAULT '5' COMMENT '删除状态 4:删除 5:正常',
                'createTime' ,//int(10) DEFAULT NULL COMMENT '创建时间',
                'updateTime' ,//int(10) DEFAULT NULL COMMENT '修改时间',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}