<?php

namespace JinDouYun\Dao\System;

use JinDouYun\Dao\BaseDao;

class DCustomerSource extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'customer_source';
        $this->_primary = 'id';
        $this->_fields = [
            "id", //int(11) NOT NULL AUTO_INCREMENT,
            "name", //varchar(255) DEFAULT NULL COMMENT '名称',
            "type", //tinyint(3) DEFAULT NULL COMMENT '类型 0:用户添加 1:全局配置',
            'modelType',//tinyint(3) DEFAULT '0' COMMENT '业务模式',
            "isEvidence", //tinyint(3) DEFAULT '4' COMMENT '是否上传营业执照',
            "createTime", //varchar(50) DEFAULT NULL COMMENT '创建时间',
            "updateTime", //varchar(50) DEFAULT NULL COMMENT '修改时间',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}