<?php
/**
 * 配送Dao
 * Created by PhpStorm.
 * User: XiaoMing
 * Date: 2019/10/31
 * Time: 15:49
 */

namespace JinDouYun\Dao\System;

use JinDouYun\Dao\BaseDao;

class DDeliverySetting extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'delivery_setting';
        $this->_primary = 'id';
        $this->_fields = [
            "id", //int(10) NOT NULL AUTO_INCREMENT,
            "deliveryType",// tinyint(3) NOT NULL COMMENT '配送方式标识 对应StatusCode中的标识',
            "enterpriseId",// int(11) NOT NULL COMMENT '企业id',
            "settingId", //varchar(50) NOT NULL DEFAULT '' COMMENT '配送方式id',
            "defaultStatus", //tinyint(3) NOT NULL DEFAULT '4' COMMENT '是否默认 默认4 否 5是',
            "enableStatus", //tinyint(3) NOT NULL DEFAULT '5' COMMENT '状态  默认5 启用 4禁用',
            "deleteStatus", //tinyint(3) NOT NULL DEFAULT '5' COMMENT '是否删除 默认5 正常 4删除',
            "extends", //json DEFAULT NULL COMMENT '拓展字段',
            "createTime", //int(10) NOT NULL DEFAULT '0' COMMENT '创建时间',
            "updateTime", //int(10) NOT NULL DEFAULT '0' COMMENT '更新时间',
            "setData",
            "title",
            "shopId"
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}