<?php
/**
 * 企业绑定模版表
 * Created by PhpStorm.
 * User: XiaoMing
 * Date: 2019/11/29
 * Time: 15:13
 */

namespace JinDouYun\Dao\System;

use JinDouYun\Dao\BaseDao;

class DEnterpriseBindTemplate extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'enterprise_bind_template';
        $this->_primary = 'id';
        $this->_fields = [
            "id",//int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
            "templateId",//int(10) NOT NULL COMMENT '模版Id',
            "enterpriseId",//int(10) NOT NULL COMMENT '企业Id',
            "enableStatus",//tinyint(3) NOT NULL DEFAULT '5' COMMENT '模版使用状态  默认5 正在使用 4未使用',
            "status",//tinyint(3) NOT NULL DEFAULT '0' COMMENT '小程序当前状态 1.提交代码后 2.提交审核后 3.发布小程序后',
            "qrcodeImg",//varchar(255) NOT NULL COMMENT '小程序体验版二维码',
            "extends",//json DEFAULT NULL COMMENT '拓展字段',
            "createTime",//int(10) NOT NULL DEFAULT '0' COMMENT '创建时间',
            "updateTime",//int(10) NOT NULL DEFAULT '0' COMMENT '更新时间',
            "auditId",//int(10) DEFAULT NULL COMMENT '审核id',
            "auditStatus",//tinyint(3) DEFAULT '2' COMMENT '微信审核状态 0审核成功 1审核被拒绝 2审核中 3已撤回 4审核延后',
            "reason",//json DEFAULT NULL COMMENT '审核失败原因',
            "version",//varchar(50) NOT NULL COMMENT '当前版本',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}