<?php
namespace JinDouYun\Dao\System;

use JinDouYun\Dao\BaseDao;

/**
 * @copyright   Copyright (c) https://www.qianniaovip.com All rights reserved
 * Description: 流程配置
 * Class DProcessSetting
 * @package JinDouYun\Dao\System
 */
class DProcessSetting extends BaseDao
{
    /**
     * DProcessSetting constructor.
     * @param string $serviceDB
     */
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'process_setting';
        $this->_primary = 'id';
        $this->_fields = [
            "id",//int(11) NOT NULL AUTO_INCREMENT,
            "processType",//int(10) NOT NULL DEFAULT '0' COMMENT '流程类型',
            "content",//json DEFAULT NULL COMMENT '流程配置',
            "enterpriseId",//int(11) NOT NULL COMMENT '企业id',
            "extends",//json DEFAULT NULL COMMENT '拓展字段',
            "createTime",//int(10) NOT NULL DEFAULT '0' COMMENT '创建时间',
            "updateTime",//int(10) NOT NULL DEFAULT '0' COMMENT '更新时间',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}