<?php
/**
 * 系统推送消息
 * Created by PhpStorm.
 * User: phperstar
 * Date: 2021/05/07
 * Time: 15:09
 */

namespace JinDouYun\Dao\System;

use JinDouYun\Dao\BaseDao;

class DSystemPushMessageSetting extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'system_push_message_setting';
        $this->_primary = 'id';
        $this->_fields = [
            'id', //int(10) NOT NULL AUTO_INCREMENT COMMENT '自增ID',
            'messageId', //int(10) NOT NULL COMMENT '推送消息模板id',
            'enterpriseId', //int(10) NOT NULL COMMENT '企业id',
            'enabledStatus', //tinyint(3) NOT NULL DEFAULT '5' COMMENT '启用状态 5启用',
            'weixinTemplateId', //varchar(255) NOT NULL COMMENT '微信订阅消息模板id',
            'weixinEnabledStatus', //tinyint(3) NOT NULL DEFAULT '5' COMMENT '微信订阅消息推送状态 5推送 4不推送',
            'smsEnabledStatus', //tinyint(3) NOT NULL DEFAULT '5' COMMENT '短信推送状态 5推送 4不推送',
            'createTime', //int(10) DEFAULT NULL COMMENT '添加时间',
            'updateTime', //int(10) DEFAULT NULL COMMENT '修改时间',
            'extend', //json DEFAULT NULL COMMENT '扩展字段',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}