<?php
/**
 * 平台模版
 * Created by PhpStorm.
 * User: XiaoMing
 * Date: 2019/11/29
 * Time: 15:09
 */

namespace JinDouYun\Dao\System;

use JinDouYun\Dao\BaseDao;

class DSystemTemplate extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'system_template';
        $this->_primary = 'id';
        $this->_fields = [
            "id", //int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
            "title", //varchar(50) NOT NULL COMMENT '模版名称',
            "weixinTemplateId", //int(11) NOT NULL COMMENT '微信模板id',
            "enableStatus", //tinyint(3) NOT NULL DEFAULT '5' COMMENT '启用状态  默认5 正常 4关闭',
            "deleteStatus", //tinyint(3) NOT NULL DEFAULT '5' COMMENT '删除状态  默认5 正常 4删除',
            "createTime", //int(10) NOT NULL DEFAULT '0' COMMENT '创建时间',
            "updateTime", //int(10) NOT NULL DEFAULT '0' COMMENT '更新时间',
            "extends", //json DEFAULT NULL COMMENT '拓展字段',
            "version", //varchar(50) DEFAULT NULL COMMENT '当前微信模版版本号',
            "type",//模版类型 1普通模版 2万能模版
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
            'createTime' => time()
        ];
        $this->_update_autofill = [
            'updateTime' => time()
        ];

        parent::__construct($serviceDB);
    }
}