<?php


namespace JinDouYun\Model\Order;

/**
 * 销售订单打印数据
 * Class SaleOrder
 * @package JinDouYun\Model\Order
 */
class SaleOrder
{
    /**
     * @var string 单号
     */
    public $no;

    /**
     * @var string 单据名称
     */
    public $receiptTitle;

    /**
     * @var string 单号名称
     */
    public $codeName;

    /**
     * @var string 客户名称
     */
    public $customerName;

    /**
     * @var int 客户手机号
     */
    public $customerMobile;

    /**
     * @var float 优惠金额
     */
    public $preferentialAmount;

    /**
     * @var float 总金额
     */
    public $totalAmount;

    /**
     * @var float 支付金额
     */
    public $payAmount;

    /**
     * @var int 时间
     */
    public $createTime;

    /**
     * @var string 店铺名称
     */
    public $shopName;

    /**
     * @var array
     */
    public $goodsDetails;

    /**
     * @var string
     */
    public $address;

    /**
     * @return string
     */
    public function getAddress(): string
    {
        return $this->address;
    }

    /**
     * @param string $address
     */
    public function setAddress(string $address): void
    {
        $this->address = $address;
    }


    /**
     * @return string
     */
    public function getNo(): string
    {
        return $this->no;
    }

    /**
     * @param string $no
     */
    public function setNo(string $no): void
    {
        $this->no = $no;
    }

    /**
     * @return string
     */
    public function getReceiptTitle(): string
    {
        return $this->receiptTitle;
    }

    /**
     * @param string $receiptTitle
     */
    public function setReceiptTitle(string $receiptTitle): void
    {
        $this->receiptTitle = $receiptTitle;
    }

    /**
     * @return string
     */
    public function getCodeName(): string
    {
        return $this->codeName;
    }

    /**
     * @param string $codeName
     */
    public function setCodeName(string $codeName): void
    {
        $this->codeName = $codeName;
    }

    /**
     * @return string
     */
    public function getCustomerName(): string
    {
        return $this->customerName;
    }

    /**
     * @param string $customerName
     */
    public function setCustomerName(string $customerName): void
    {
        $this->customerName = $customerName;
    }

    /**
     * @return int
     */
    public function getCustomerMobile(): int
    {
        return $this->customerMobile;
    }

    /**
     * @param int $customerMobile
     */
    public function setCustomerMobile(int $customerMobile): void
    {
        $this->customerMobile = $customerMobile;
    }

    /**
     * @return float
     */
    public function getPreferentialAmount(): float
    {
        return $this->preferentialAmount;
    }

    /**
     * @param float $preferentialAmount
     */
    public function setPreferentialAmount(float $preferentialAmount): void
    {
        $this->preferentialAmount = $preferentialAmount;
    }

    /**
     * @return float
     */
    public function getTotalAmount(): float
    {
        return $this->totalAmount;
    }

    /**
     * @param float $totalAmount
     */
    public function setTotalAmount(float $totalAmount): void
    {
        $this->totalAmount = $totalAmount;
    }

    /**
     * @return float
     */
    public function getPayAmount(): float
    {
        return $this->payAmount;
    }

    /**
     * @param float $payAmount
     */
    public function setPayAmount(float $payAmount): void
    {
        $this->payAmount = $payAmount;
    }

    /**
     * @return array
     */
    public function getGoodsDetails(): array
    {
        return (array)$this->goodsDetails;
    }

    /**
     * @param array $goodsDetails
     */
    public function setGoodsDetails(array $goodsDetails): void
    {
        $this->goodsDetails = $goodsDetails;
    }

    /**
     * @return int
     */
    public function getCreateTime(): int
    {
        return $this->createTime;
    }

    /**
     * @param int $createTime
     */
    public function setCreateTime(int $createTime): void
    {
        $this->createTime = $createTime;
    }

    /**
     * @return string
     */
    public function getShopName(): string
    {
        return $this->shopName;
    }

    /**
     * @param string $shopName
     */
    public function setShopName(string $shopName): void
    {
        $this->shopName = $shopName;
    }

}