<?php
/**
 * 商铺管理模块
 * Created by PhpStorm.
 * User: wxj
 * Date: 2019/10/31
 * Time: 15:02
 */

namespace JinDouYun\Model\Shop;

use Exception;

use JinDouYun\Controller\Common\Logger;
use JinDouYun\Dao\Department\DStaff;
use JinDouYun\Dao\GoodsManage\DGoodsBasic;
use JinDouYun\Dao\Shop\DShopClock;
use JinDouYun\Dao\Shop\DShopProject;
use JinDouYun\Dao\Shop\DShopTemplate;
use JinDouYun\Dao\UserCenter\DUserCenter;
use JinDouYun\Model\Common\Location;
use Mall\Framework\Core\ErrorCode;
use Mall\Framework\Core\StatusCode;
use Mall\Framework\Core\ResultWrapper;

use JinDouYun\Dao\Shop\DShop;
use JinDouYun\Dao\Shop\DEnterpriseBindShop;

use Jindouyun\Cache\EnterpriseCache;
use JinDouYun\Cache\RoleAclCache;
use JinDouYun\Cache\ShopCache;
use JinDouYun\Cache\SysAreaChinaCache;
use JinDouYun\Cache\GoodsBasicRelevant;

use JinDouYun\Model\ShopPartner\MShopPartner;
use JinDouYun\Model\Stock\MWarehouse;
use JinDouYun\Model\SysAreaChina\MSysAreaChina;
use JinDouYun\Model\Customer\MCustomer;
use JinDouYun\Model\Enterprise\MEnterprise;
use JinDouYun\Model\Department\MStaff;
use JinDouYun\Model\MBaseModel;
use Monolog\Handler\IFTTTHandler;


class MShopClock extends MBaseModel
{

    private $obj;
    private $cutTable = 250000;
    private $enterpriseId;
    private $userCenterId;
    private $objMShopPartner;
    private $objMStaff;

    public function __construct($enterpriseId, $userCenterId = '')
    {
        $this->enterpriseId = $enterpriseId;
        $this->userCenterId = $userCenterId;
        parent::__construct($this->enterpriseId, $this->userCenterId);
        $this->obj = new DShopClock('default');

    }

    /**
     * 列表
     * @param $where
     * @return mixed
     */
    public function list($where)
    {
        $limit = $where['limit'];
        unset($where['limit']);
        $offset = $where['offset'];
        unset($where['offset']);

        $file = ' a.* ';
        $sql = 'SELECT'.$file.'FROM qianniao_shop_clock'.$this->enterpriseId.' AS a WHERE shop_id = '. $where['shop_id'];

        if(isset($where['uid'])) {
            $sql .= ' AND a.uid = '.$where['uid'];
        }

        if(isset($where['start_time']) and isset($where['end_time'])) {
            $time_field = '';

            $time_field .= '"'.$where['start_time'].'",'.'"'.$where['end_time'].'"';

            $sql .= ' AND a.time in ('.$time_field.')';
        }


        $total = count((array) $this->obj->query($sql));

        $sql .= ' ORDER BY createTime DESC LIMiT '.$offset.','.$limit;

        $dbResult = $this->obj->query($sql);

        if ($dbResult === false) {
            return ResultWrapper::fail($this->obj->error(), ErrorCode::$dberror);
        }

        $return = [
            'data' => $dbResult,
            'total' => ($total) ? intval($total) : 0,
        ];

        if($return === false){
            return ResultWrapper::fail($this->obj->error(), ErrorCode::$dberror);
        }else{
            return ResultWrapper::success($return);
        }
    }


    /**
     * 详情
     * @param $where
     * @return mixed
     */
    public function details($where)
    {
        if(empty($where)){
            return ResultWrapper::success($where);
        }
        $dbResult = $this->obj->get($where);
        if($dbResult === false){
            return ResultWrapper::fail($this->obj->error(), ErrorCode::$dberror);
        }

        return ResultWrapper::success(self::formatInfo($dbResult));

    }

    /**
     * Doc: (des="添加")
     * User: XMing
     * Date: 2020/7/15
     * Time: 10:42 上午
     * @throws Exception
     * @param array $params
     * @return ResultWrapper
     */
    public function insert(array $params)
    {
        $res = $this->obj->insert($params);
        if ($res){
            return ResultWrapper::success('添加成功');
        }else{
            return ResultWrapper::fail($this->obj->error(), ErrorCode::$dberror);
        }

    }

    public function update($params, $id)
    {
        $data = $this->obj->get($id);
        if (!$data){
            return ResultWrapper::fail('数据不存在', ErrorCode::$dberror);
        }

        $dbResult = $this->obj->update($params,$id);
        if($dbResult === false){
            return ResultWrapper::fail($this->obj->error(), ErrorCode::$dberror);
        }
        return ResultWrapper::success('修改成功');

    }

    /**
     * 格式数据详情
     * @param $data
     * @return mixed
     */
    public function formatInfo($data)
    {
        return $data;
    }


    public function delete($id)
    {
        $res = $this->obj->delete(['id' => $id]);
        if ($res){
            return ResultWrapper::success('删除成功');
        }
        return ResultWrapper::fail($this->obj->error(), ErrorCode::$dberror);
    }

}